package de.fhtw.dataprofiler.dbconnectivity;

import java.sql.Connection;

/**
 * Implementation of Singleton-Patterns for the active 
 * database connection
 */
public class ActiveConnection {
	private static ActiveConnection instance = null;
	
	//Active db-connection
	Connection connection;
	
	/**
	 * Default-Constructor, not callable from outside
	 */
	private ActiveConnection() {}
	
	/**
	 * static instance, offers the only instance of connection
	 */
	public static ActiveConnection getInstance() {
        if (instance == null) {
            instance = new ActiveConnection();
        }
        return instance;
    }

	/**
	 * @return the connection
	 */
	public Connection getConnection() {
		return connection;
	}

	/**
	 * @param connection the connection to set
	 */
	public void setConnection(Connection connection) {
		this.connection = connection;
	}

	
}
