package de.fhtw.dataprofiler.dbconnectivity.handlers;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.swt.widgets.Display;

import de.fhtw.dataprofiler.dbconnectivity.wizards.ConnectionWizard;

/**
 * Connect To Database handler extends AbstractHandler, an IHandler base class.
 * 
 * 
 * @see org.eclipse.core.commands.IHandler
 * @see org.eclipse.core.commands.AbstractHandler
 */
public class ConnectToDBHandler extends AbstractHandler {
	/**
	 * The constructor.
	 */
	public ConnectToDBHandler() {
	}

	/**
	 * Opens Connection Wizard
	 * 
	 * the command has been executed, so extract the needed information
	 * from the application context.
	 */
	public Object execute(ExecutionEvent event) throws ExecutionException {
		//Open own Connection Wizard through standard WizardDialog
		ConnectionWizard connectionWizard = new ConnectionWizard();
		connectionWizard.setNeedsProgressMonitor(true);
		WizardDialog dialog = new WizardDialog(Display.getCurrent().getActiveShell(), connectionWizard);
		dialog.setMinimumPageSize(300, 350);
		dialog.create();
		dialog.open();

		return null;
	}
}
