package de.fhtw.dataprofiler.dbconnectivity.handlers;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.datatools.connectivity.internal.ui.dialogs.DriverDefinitionsDialog;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.handlers.HandlerUtil;

/**
 * Driver Definitions handler extends AbstractHandler, an IHandler base class.
 * 
 * @see org.eclipse.core.commands.IHandler
 * @see org.eclipse.core.commands.AbstractHandler
 */
public class DriverDefinitionsHandler extends AbstractHandler {
	/**
	 * The constructor.
	 */
	public DriverDefinitionsHandler() {
	}

	/**
	 * Open the driver definition dialog
	 * 
	 * the command has been executed, so extract extract the needed information
	 * from the application context.
	 */
	public Object execute(ExecutionEvent event) throws ExecutionException {
		IWorkbenchWindow window = HandlerUtil.getActiveWorkbenchWindowChecked(event);
		DriverDefinitionsDialog dialog = new DriverDefinitionsDialog(window.getShell());
		dialog.open();
		return null;
	}
}
