package de.fhtw.dataprofiler.dbconnectivity.popup.actions;

import java.sql.Connection;

import org.eclipse.core.resources.IResource;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.ui.IActionDelegate;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;

import de.fhtw.dataprofiler.dbconnectivity.ActiveConnection;
import de.fhtw.dataprofiler.dbconnectivity.reverseengineerer.ReverseEngineerer;
import de.fhtw.dataprofiler.dbconnectivity.wizards.ConnectionWizard;

/**
 * Reverse Engineering implements IObjectActionDelegate.
 * 
 * @deprecated use handler instead
 */
public class LaunchReverseEngineerer implements IObjectActionDelegate {

	private IResource selectedResource;

	/**
	 * Constructor for Action1.
	 */
	public LaunchReverseEngineerer() {
		super();
	}

	/**
	 * @see IObjectActionDelegate#setActivePart(IAction, IWorkbenchPart)
	 */
	public void setActivePart(IAction action, IWorkbenchPart targetPart) {
	}

	/**
	 * @deprecated !!!use handler class instead
	 * 
	 * @see IActionDelegate#run(IAction)
	 */
	public void run(IAction action) {

		ConnectionWizard wizard = new ConnectionWizard();
		wizard.setNeedsProgressMonitor(true);

		WizardDialog dialog = new WizardDialog(Display.getCurrent().getActiveShell(), wizard);
		dialog.setMinimumPageSize(300, 350);
		dialog.create();
		dialog.open();

		Connection connection = ActiveConnection.getInstance().getConnection();
		if (connection != null) {
			new ReverseEngineerer().startReverseEngineering(connection, selectedResource.getFullPath());
		}

	}

	/**
	 * @see IActionDelegate#selectionChanged(IAction, ISelection)
	 */
	public void selectionChanged(IAction action, ISelection selection) {
		if (selection instanceof IStructuredSelection) {
			Object sel = ((IStructuredSelection) selection).getFirstElement();
			if (sel instanceof IResource) {
				selectedResource = (IResource) sel;
			}
		}

	}

}
