/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package de.fhtw.dataprofiler.sqlmodel.accesscontrol;

import de.fhtw.dataprofiler.sqlmodel.schema.Database;
import de.fhtw.dataprofiler.sqlmodel.schema.SQLObject;
import de.fhtw.dataprofiler.sqlmodel.schema.Schema;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Authorization Identifier</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.AuthorizationIdentifier#getOwnedSchema <em>Owned Schema</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.AuthorizationIdentifier#getDatabase <em>Database</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.AuthorizationIdentifier#getReceivedRoleAuthorization <em>Received Role Authorization</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.AuthorizationIdentifier#getGrantedRoleAuthorization <em>Granted Role Authorization</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.AuthorizationIdentifier#getGrantedPrivilege <em>Granted Privilege</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.AuthorizationIdentifier#getReceivedPrivilege <em>Received Privilege</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.fhtw.dataprofiler.sqlmodel.accesscontrol.AccesscontrolPackage#getAuthorizationIdentifier()
 * @model abstract="true"
 * @generated
 */
public interface AuthorizationIdentifier extends SQLObject {
	/**
	 * Returns the value of the '<em><b>Owned Schema</b></em>' reference list.
	 * The list contents are of type {@link de.fhtw.dataprofiler.sqlmodel.schema.Schema}.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.schema.Schema#getOwner <em>Owner</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Owned Schema</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Owned Schema</em>' reference list.
	 * @see de.fhtw.dataprofiler.sqlmodel.accesscontrol.AccesscontrolPackage#getAuthorizationIdentifier_OwnedSchema()
	 * @see de.fhtw.dataprofiler.sqlmodel.schema.Schema#getOwner
	 * @model opposite="owner"
	 * @generated
	 */
	EList<Schema> getOwnedSchema();

	/**
	 * Returns the value of the '<em><b>Database</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.schema.Database#getAuthorizationIds <em>Authorization Ids</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Database</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Database</em>' reference.
	 * @see #setDatabase(Database)
	 * @see de.fhtw.dataprofiler.sqlmodel.accesscontrol.AccesscontrolPackage#getAuthorizationIdentifier_Database()
	 * @see de.fhtw.dataprofiler.sqlmodel.schema.Database#getAuthorizationIds
	 * @model opposite="authorizationIds" required="true"
	 * @generated
	 */
	Database getDatabase();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.AuthorizationIdentifier#getDatabase <em>Database</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Database</em>' reference.
	 * @see #getDatabase()
	 * @generated
	 */
	void setDatabase(Database value);

	/**
	 * Returns the value of the '<em><b>Received Role Authorization</b></em>' reference list.
	 * The list contents are of type {@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.RoleAuthorization}.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.RoleAuthorization#getGrantee <em>Grantee</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Received Role Authorization</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Received Role Authorization</em>' reference list.
	 * @see de.fhtw.dataprofiler.sqlmodel.accesscontrol.AccesscontrolPackage#getAuthorizationIdentifier_ReceivedRoleAuthorization()
	 * @see de.fhtw.dataprofiler.sqlmodel.accesscontrol.RoleAuthorization#getGrantee
	 * @model opposite="grantee"
	 * @generated
	 */
	EList<RoleAuthorization> getReceivedRoleAuthorization();

	/**
	 * Returns the value of the '<em><b>Granted Role Authorization</b></em>' reference list.
	 * The list contents are of type {@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.RoleAuthorization}.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.RoleAuthorization#getGrantor <em>Grantor</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Granted Role Authorization</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Granted Role Authorization</em>' reference list.
	 * @see de.fhtw.dataprofiler.sqlmodel.accesscontrol.AccesscontrolPackage#getAuthorizationIdentifier_GrantedRoleAuthorization()
	 * @see de.fhtw.dataprofiler.sqlmodel.accesscontrol.RoleAuthorization#getGrantor
	 * @model opposite="grantor"
	 * @generated
	 */
	EList<RoleAuthorization> getGrantedRoleAuthorization();

	/**
	 * Returns the value of the '<em><b>Granted Privilege</b></em>' reference list.
	 * The list contents are of type {@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.Privilege}.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.Privilege#getGrantor <em>Grantor</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Granted Privilege</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Granted Privilege</em>' reference list.
	 * @see de.fhtw.dataprofiler.sqlmodel.accesscontrol.AccesscontrolPackage#getAuthorizationIdentifier_GrantedPrivilege()
	 * @see de.fhtw.dataprofiler.sqlmodel.accesscontrol.Privilege#getGrantor
	 * @model opposite="grantor"
	 * @generated
	 */
	EList<Privilege> getGrantedPrivilege();

	/**
	 * Returns the value of the '<em><b>Received Privilege</b></em>' containment reference list.
	 * The list contents are of type {@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.Privilege}.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.Privilege#getGrantee <em>Grantee</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Received Privilege</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Received Privilege</em>' containment reference list.
	 * @see de.fhtw.dataprofiler.sqlmodel.accesscontrol.AccesscontrolPackage#getAuthorizationIdentifier_ReceivedPrivilege()
	 * @see de.fhtw.dataprofiler.sqlmodel.accesscontrol.Privilege#getGrantee
	 * @model opposite="grantee" containment="true"
	 * @generated
	 */
	EList<Privilege> getReceivedPrivilege();

} // AuthorizationIdentifier
