/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package de.fhtw.dataprofiler.sqlmodel.accesscontrol;

import de.fhtw.dataprofiler.sqlmodel.schema.SQLObject;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Privilege</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.Privilege#isGrantable <em>Grantable</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.Privilege#getAction <em>Action</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.Privilege#isWithHierarchy <em>With Hierarchy</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.Privilege#getGrantor <em>Grantor</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.Privilege#getGrantee <em>Grantee</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.Privilege#getActionObjects <em>Action Objects</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.Privilege#getObject <em>Object</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.fhtw.dataprofiler.sqlmodel.accesscontrol.AccesscontrolPackage#getPrivilege()
 * @model
 * @generated
 */
public interface Privilege extends SQLObject {
	/**
	 * Returns the value of the '<em><b>Grantable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Grantable</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Grantable</em>' attribute.
	 * @see #setGrantable(boolean)
	 * @see de.fhtw.dataprofiler.sqlmodel.accesscontrol.AccesscontrolPackage#getPrivilege_Grantable()
	 * @model
	 * @generated
	 */
	boolean isGrantable();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.Privilege#isGrantable <em>Grantable</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Grantable</em>' attribute.
	 * @see #isGrantable()
	 * @generated
	 */
	void setGrantable(boolean value);

	/**
	 * Returns the value of the '<em><b>Action</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Action</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Action</em>' attribute.
	 * @see #setAction(String)
	 * @see de.fhtw.dataprofiler.sqlmodel.accesscontrol.AccesscontrolPackage#getPrivilege_Action()
	 * @model
	 * @generated
	 */
	String getAction();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.Privilege#getAction <em>Action</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Action</em>' attribute.
	 * @see #getAction()
	 * @generated
	 */
	void setAction(String value);

	/**
	 * Returns the value of the '<em><b>With Hierarchy</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>With Hierarchy</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>With Hierarchy</em>' attribute.
	 * @see #setWithHierarchy(boolean)
	 * @see de.fhtw.dataprofiler.sqlmodel.accesscontrol.AccesscontrolPackage#getPrivilege_WithHierarchy()
	 * @model
	 * @generated
	 */
	boolean isWithHierarchy();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.Privilege#isWithHierarchy <em>With Hierarchy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>With Hierarchy</em>' attribute.
	 * @see #isWithHierarchy()
	 * @generated
	 */
	void setWithHierarchy(boolean value);

	/**
	 * Returns the value of the '<em><b>Grantor</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.AuthorizationIdentifier#getGrantedPrivilege <em>Granted Privilege</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Grantor</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Grantor</em>' reference.
	 * @see #setGrantor(AuthorizationIdentifier)
	 * @see de.fhtw.dataprofiler.sqlmodel.accesscontrol.AccesscontrolPackage#getPrivilege_Grantor()
	 * @see de.fhtw.dataprofiler.sqlmodel.accesscontrol.AuthorizationIdentifier#getGrantedPrivilege
	 * @model opposite="grantedPrivilege" required="true"
	 * @generated
	 */
	AuthorizationIdentifier getGrantor();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.Privilege#getGrantor <em>Grantor</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Grantor</em>' reference.
	 * @see #getGrantor()
	 * @generated
	 */
	void setGrantor(AuthorizationIdentifier value);

	/**
	 * Returns the value of the '<em><b>Grantee</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.AuthorizationIdentifier#getReceivedPrivilege <em>Received Privilege</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Grantee</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Grantee</em>' container reference.
	 * @see #setGrantee(AuthorizationIdentifier)
	 * @see de.fhtw.dataprofiler.sqlmodel.accesscontrol.AccesscontrolPackage#getPrivilege_Grantee()
	 * @see de.fhtw.dataprofiler.sqlmodel.accesscontrol.AuthorizationIdentifier#getReceivedPrivilege
	 * @model opposite="receivedPrivilege"
	 * @generated
	 */
	AuthorizationIdentifier getGrantee();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.Privilege#getGrantee <em>Grantee</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Grantee</em>' container reference.
	 * @see #getGrantee()
	 * @generated
	 */
	void setGrantee(AuthorizationIdentifier value);

	/**
	 * Returns the value of the '<em><b>Action Objects</b></em>' reference list.
	 * The list contents are of type {@link de.fhtw.dataprofiler.sqlmodel.schema.SQLObject}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Action Objects</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Action Objects</em>' reference list.
	 * @see de.fhtw.dataprofiler.sqlmodel.accesscontrol.AccesscontrolPackage#getPrivilege_ActionObjects()
	 * @model
	 * @generated
	 */
	EList<SQLObject> getActionObjects();

	/**
	 * Returns the value of the '<em><b>Object</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.schema.SQLObject#getPrivileges <em>Privileges</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Object</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Object</em>' reference.
	 * @see #setObject(SQLObject)
	 * @see de.fhtw.dataprofiler.sqlmodel.accesscontrol.AccesscontrolPackage#getPrivilege_Object()
	 * @see de.fhtw.dataprofiler.sqlmodel.schema.SQLObject#getPrivileges
	 * @model opposite="privileges" required="true"
	 * @generated
	 */
	SQLObject getObject();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.Privilege#getObject <em>Object</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Object</em>' reference.
	 * @see #getObject()
	 * @generated
	 */
	void setObject(SQLObject value);

} // Privilege
