/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package de.fhtw.dataprofiler.sqlmodel.datatypes;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Link Control Option</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see de.fhtw.dataprofiler.sqlmodel.datatypes.DatatypesPackage#getLinkControlOption()
 * @model
 * @generated
 */
public enum LinkControlOption implements Enumerator {
	/**
	 * The '<em><b>FILE LINK CONTROL</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #FILE_LINK_CONTROL_VALUE
	 * @generated
	 * @ordered
	 */
	FILE_LINK_CONTROL(0, "FILE_LINK_CONTROL", "FILE_LINK_CONTROL"),

	/**
	 * The '<em><b>NO FILE LINK CONTROL</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #NO_FILE_LINK_CONTROL_VALUE
	 * @generated
	 * @ordered
	 */
	NO_FILE_LINK_CONTROL(1, "NO_FILE_LINK_CONTROL", "NO_FILE_LINK_CONTROL");

	/**
	 * The '<em><b>FILE LINK CONTROL</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>FILE LINK CONTROL</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #FILE_LINK_CONTROL
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int FILE_LINK_CONTROL_VALUE = 0;

	/**
	 * The '<em><b>NO FILE LINK CONTROL</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>NO FILE LINK CONTROL</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #NO_FILE_LINK_CONTROL
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int NO_FILE_LINK_CONTROL_VALUE = 1;

	/**
	 * An array of all the '<em><b>Link Control Option</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final LinkControlOption[] VALUES_ARRAY =
		new LinkControlOption[] {
			FILE_LINK_CONTROL,
			NO_FILE_LINK_CONTROL,
		};

	/**
	 * A public read-only list of all the '<em><b>Link Control Option</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<LinkControlOption> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Link Control Option</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static LinkControlOption get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			LinkControlOption result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Link Control Option</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static LinkControlOption getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			LinkControlOption result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Link Control Option</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static LinkControlOption get(int value) {
		switch (value) {
			case FILE_LINK_CONTROL_VALUE: return FILE_LINK_CONTROL;
			case NO_FILE_LINK_CONTROL_VALUE: return NO_FILE_LINK_CONTROL;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private LinkControlOption(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //LinkControlOption
