/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package de.fhtw.dataprofiler.sqlmodel.datatypes.impl;

import de.fhtw.dataprofiler.sqlmodel.accesscontrol.AccesscontrolPackage;

import de.fhtw.dataprofiler.sqlmodel.accesscontrol.impl.AccesscontrolPackageImpl;

import de.fhtw.dataprofiler.sqlmodel.constraints.ConstraintsPackage;

import de.fhtw.dataprofiler.sqlmodel.constraints.impl.ConstraintsPackageImpl;

import de.fhtw.dataprofiler.sqlmodel.datatypes.ApproximateNumericDataType;
import de.fhtw.dataprofiler.sqlmodel.datatypes.ArrayDataType;
import de.fhtw.dataprofiler.sqlmodel.datatypes.AttributeDefinition;
import de.fhtw.dataprofiler.sqlmodel.datatypes.BinaryStringDataType;
import de.fhtw.dataprofiler.sqlmodel.datatypes.BooleanDataType;
import de.fhtw.dataprofiler.sqlmodel.datatypes.CharacterSet;
import de.fhtw.dataprofiler.sqlmodel.datatypes.CharacterStringDataType;
import de.fhtw.dataprofiler.sqlmodel.datatypes.CoercibilityType;
import de.fhtw.dataprofiler.sqlmodel.datatypes.CollectionDataType;
import de.fhtw.dataprofiler.sqlmodel.datatypes.ConstructedDataType;
import de.fhtw.dataprofiler.sqlmodel.datatypes.DataLinkDataType;
import de.fhtw.dataprofiler.sqlmodel.datatypes.DataType;
import de.fhtw.dataprofiler.sqlmodel.datatypes.DatatypesFactory;
import de.fhtw.dataprofiler.sqlmodel.datatypes.DatatypesPackage;
import de.fhtw.dataprofiler.sqlmodel.datatypes.DateDataType;
import de.fhtw.dataprofiler.sqlmodel.datatypes.DistinctUserDefinedType;
import de.fhtw.dataprofiler.sqlmodel.datatypes.Domain;
import de.fhtw.dataprofiler.sqlmodel.datatypes.ExactNumericDataType;
import de.fhtw.dataprofiler.sqlmodel.datatypes.Field;
import de.fhtw.dataprofiler.sqlmodel.datatypes.FixedPrecisionDataType;
import de.fhtw.dataprofiler.sqlmodel.datatypes.IntegerDataType;
import de.fhtw.dataprofiler.sqlmodel.datatypes.IntegrityControlOption;
import de.fhtw.dataprofiler.sqlmodel.datatypes.IntervalDataType;
import de.fhtw.dataprofiler.sqlmodel.datatypes.IntervalQualifierType;
import de.fhtw.dataprofiler.sqlmodel.datatypes.LinkControlOption;
import de.fhtw.dataprofiler.sqlmodel.datatypes.MultisetDataType;
import de.fhtw.dataprofiler.sqlmodel.datatypes.NumericalDataType;
import de.fhtw.dataprofiler.sqlmodel.datatypes.OrderingCategoryType;
import de.fhtw.dataprofiler.sqlmodel.datatypes.OrderingType;
import de.fhtw.dataprofiler.sqlmodel.datatypes.PredefinedDataType;
import de.fhtw.dataprofiler.sqlmodel.datatypes.PrimitiveType;
import de.fhtw.dataprofiler.sqlmodel.datatypes.ReadPermissionOption;
import de.fhtw.dataprofiler.sqlmodel.datatypes.ReferenceDataType;
import de.fhtw.dataprofiler.sqlmodel.datatypes.RowDataType;
import de.fhtw.dataprofiler.sqlmodel.datatypes.SQLDataType;
import de.fhtw.dataprofiler.sqlmodel.datatypes.StructuredUserDefinedType;
import de.fhtw.dataprofiler.sqlmodel.datatypes.TimeDataType;
import de.fhtw.dataprofiler.sqlmodel.datatypes.UnlinkOption;
import de.fhtw.dataprofiler.sqlmodel.datatypes.UserDefinedType;
import de.fhtw.dataprofiler.sqlmodel.datatypes.UserDefinedTypeOrdering;
import de.fhtw.dataprofiler.sqlmodel.datatypes.WritePermissionOption;
import de.fhtw.dataprofiler.sqlmodel.datatypes.XMLDataType;

import de.fhtw.dataprofiler.sqlmodel.expressions.ExpressionsPackage;

import de.fhtw.dataprofiler.sqlmodel.expressions.impl.ExpressionsPackageImpl;

import de.fhtw.dataprofiler.sqlmodel.routines.RoutinesPackage;

import de.fhtw.dataprofiler.sqlmodel.routines.impl.RoutinesPackageImpl;

import de.fhtw.dataprofiler.sqlmodel.schema.SchemaPackage;

import de.fhtw.dataprofiler.sqlmodel.schema.impl.SchemaPackageImpl;

import de.fhtw.dataprofiler.sqlmodel.statements.StatementsPackage;

import de.fhtw.dataprofiler.sqlmodel.statements.impl.StatementsPackageImpl;

import de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage;

import de.fhtw.dataprofiler.sqlmodel.tables.impl.TablesPackageImpl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EcorePackage;

import org.eclipse.emf.ecore.impl.EPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class DatatypesPackageImpl extends EPackageImpl implements DatatypesPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass userDefinedTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass dataTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass predefinedDataTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass collectionDataTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass numericalDataTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass characterStringDataTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass rowDataTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass arrayDataTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass multisetDataTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass booleanDataTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass intervalDataTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass binaryStringDataTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass characterSetEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass timeDataTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass distinctUserDefinedTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass structuredUserDefinedTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass attributeDefinitionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass fixedPrecisionDataTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass domainEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass fieldEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass referenceDataTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass constructedDataTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass sqlDataTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass dataLinkDataTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass userDefinedTypeOrderingEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass dateDataTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass exactNumericDataTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass approximateNumericDataTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass integerDataTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass xmlDataTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum coercibilityTypeEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum intervalQualifierTypeEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum orderingTypeEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum orderingCategoryTypeEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum primitiveTypeEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum linkControlOptionEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum integrityControlOptionEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum readPermissionOptionEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum writePermissionOptionEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum unlinkOptionEEnum = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see de.fhtw.dataprofiler.sqlmodel.datatypes.DatatypesPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private DatatypesPackageImpl() {
		super(eNS_URI, DatatypesFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this
	 * model, and for any others upon which it depends.  Simple
	 * dependencies are satisfied by calling this method on all
	 * dependent packages before doing anything else.  This method drives
	 * initialization for interdependent packages directly, in parallel
	 * with this package, itself.
	 * <p>Of this package and its interdependencies, all packages which
	 * have not yet been registered by their URI values are first created
	 * and registered.  The packages are then initialized in two steps:
	 * meta-model objects for all of the packages are created before any
	 * are initialized, since one package's meta-model objects may refer to
	 * those of another.
	 * <p>Invocation of this method will not affect any packages that have
	 * already been initialized.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static DatatypesPackage init() {
		if (isInited) return (DatatypesPackage)EPackage.Registry.INSTANCE.getEPackage(DatatypesPackage.eNS_URI);

		// Obtain or create and register package
		DatatypesPackageImpl theDatatypesPackage = (DatatypesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(eNS_URI) instanceof DatatypesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(eNS_URI) : new DatatypesPackageImpl());

		isInited = true;

		// Initialize simple dependencies
		EcorePackage.eINSTANCE.eClass();

		// Obtain or create and register interdependencies
		SchemaPackageImpl theSchemaPackage = (SchemaPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SchemaPackage.eNS_URI) instanceof SchemaPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SchemaPackage.eNS_URI) : SchemaPackage.eINSTANCE);
		ConstraintsPackageImpl theConstraintsPackage = (ConstraintsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ConstraintsPackage.eNS_URI) instanceof ConstraintsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ConstraintsPackage.eNS_URI) : ConstraintsPackage.eINSTANCE);
		ExpressionsPackageImpl theExpressionsPackage = (ExpressionsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ExpressionsPackage.eNS_URI) instanceof ExpressionsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ExpressionsPackage.eNS_URI) : ExpressionsPackage.eINSTANCE);
		RoutinesPackageImpl theRoutinesPackage = (RoutinesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(RoutinesPackage.eNS_URI) instanceof RoutinesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(RoutinesPackage.eNS_URI) : RoutinesPackage.eINSTANCE);
		StatementsPackageImpl theStatementsPackage = (StatementsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(StatementsPackage.eNS_URI) instanceof StatementsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(StatementsPackage.eNS_URI) : StatementsPackage.eINSTANCE);
		TablesPackageImpl theTablesPackage = (TablesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(TablesPackage.eNS_URI) instanceof TablesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(TablesPackage.eNS_URI) : TablesPackage.eINSTANCE);
		AccesscontrolPackageImpl theAccesscontrolPackage = (AccesscontrolPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(AccesscontrolPackage.eNS_URI) instanceof AccesscontrolPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(AccesscontrolPackage.eNS_URI) : AccesscontrolPackage.eINSTANCE);

		// Create package meta-data objects
		theDatatypesPackage.createPackageContents();
		theSchemaPackage.createPackageContents();
		theConstraintsPackage.createPackageContents();
		theExpressionsPackage.createPackageContents();
		theRoutinesPackage.createPackageContents();
		theStatementsPackage.createPackageContents();
		theTablesPackage.createPackageContents();
		theAccesscontrolPackage.createPackageContents();

		// Initialize created meta-data
		theDatatypesPackage.initializePackageContents();
		theSchemaPackage.initializePackageContents();
		theConstraintsPackage.initializePackageContents();
		theExpressionsPackage.initializePackageContents();
		theRoutinesPackage.initializePackageContents();
		theStatementsPackage.initializePackageContents();
		theTablesPackage.initializePackageContents();
		theAccesscontrolPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theDatatypesPackage.freeze();

		return theDatatypesPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getUserDefinedType() {
		return userDefinedTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getUserDefinedType_Schema() {
		return (EReference)userDefinedTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getUserDefinedType_Ordering() {
		return (EReference)userDefinedTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDataType() {
		return dataTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPredefinedDataType() {
		return predefinedDataTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getPredefinedDataType_PrimitiveType() {
		return (EAttribute)predefinedDataTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCollectionDataType() {
		return collectionDataTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCollectionDataType_Element() {
		return (EReference)collectionDataTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNumericalDataType() {
		return numericalDataTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNumericalDataType_Precision() {
		return (EAttribute)numericalDataTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCharacterStringDataType() {
		return characterStringDataTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCharacterStringDataType_Length() {
		return (EAttribute)characterStringDataTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCharacterStringDataType_Coercibility() {
		return (EAttribute)characterStringDataTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCharacterStringDataType_FixedLength() {
		return (EAttribute)characterStringDataTypeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCharacterStringDataType_CollationName() {
		return (EAttribute)characterStringDataTypeEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCharacterStringDataType_CharacterSet() {
		return (EReference)characterStringDataTypeEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRowDataType() {
		return rowDataTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRowDataType_Fields() {
		return (EReference)rowDataTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getArrayDataType() {
		return arrayDataTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getArrayDataType_MaxCardinality() {
		return (EAttribute)arrayDataTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMultisetDataType() {
		return multisetDataTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBooleanDataType() {
		return booleanDataTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getIntervalDataType() {
		return intervalDataTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getIntervalDataType_LeadingQualifier() {
		return (EAttribute)intervalDataTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getIntervalDataType_TrailingQualifier() {
		return (EAttribute)intervalDataTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getIntervalDataType_LeadingFieldPrecision() {
		return (EAttribute)intervalDataTypeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getIntervalDataType_TrailingFieldPrecision() {
		return (EAttribute)intervalDataTypeEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getIntervalDataType_FractionalSecondsPrecision() {
		return (EAttribute)intervalDataTypeEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBinaryStringDataType() {
		return binaryStringDataTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getBinaryStringDataType_Length() {
		return (EAttribute)binaryStringDataTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCharacterSet() {
		return characterSetEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCharacterSet_Repertoire() {
		return (EAttribute)characterSetEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCharacterSet_DefaultCollation() {
		return (EAttribute)characterSetEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCharacterSet_Encoding() {
		return (EAttribute)characterSetEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCharacterSet_Schema() {
		return (EReference)characterSetEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTimeDataType() {
		return timeDataTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTimeDataType_FractionalSecondsPrecision() {
		return (EAttribute)timeDataTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTimeDataType_TimeZone() {
		return (EAttribute)timeDataTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDistinctUserDefinedType() {
		return distinctUserDefinedTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDistinctUserDefinedType_PredefinedRepresentation() {
		return (EReference)distinctUserDefinedTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getStructuredUserDefinedType() {
		return structuredUserDefinedTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getStructuredUserDefinedType_Instantiable() {
		return (EAttribute)structuredUserDefinedTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getStructuredUserDefinedType_Final() {
		return (EAttribute)structuredUserDefinedTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getStructuredUserDefinedType_Super() {
		return (EReference)structuredUserDefinedTypeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getStructuredUserDefinedType_Sub() {
		return (EReference)structuredUserDefinedTypeEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getStructuredUserDefinedType_Attributes() {
		return (EReference)structuredUserDefinedTypeEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getStructuredUserDefinedType_Methods() {
		return (EReference)structuredUserDefinedTypeEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAttributeDefinition() {
		return attributeDefinitionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAttributeDefinition_ScopeCheck() {
		return (EAttribute)attributeDefinitionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAttributeDefinition_ScopeChecked() {
		return (EAttribute)attributeDefinitionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAttributeDefinition_DefaultValue() {
		return (EAttribute)attributeDefinitionEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getFixedPrecisionDataType() {
		return fixedPrecisionDataTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDomain() {
		return domainEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDomain_Constraint() {
		return (EReference)domainEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDomain_DefaultValue() {
		return (EAttribute)domainEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getField() {
		return fieldEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getField_ScopeCheck() {
		return (EAttribute)fieldEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getField_ScopeChecked() {
		return (EAttribute)fieldEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getReferenceDataType() {
		return referenceDataTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getReferenceDataType_ScopeTable() {
		return (EReference)referenceDataTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getReferenceDataType_ReferencedType() {
		return (EReference)referenceDataTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getConstructedDataType() {
		return constructedDataTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSQLDataType() {
		return sqlDataTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDataLinkDataType() {
		return dataLinkDataTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDataLinkDataType_Length() {
		return (EAttribute)dataLinkDataTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDataLinkDataType_LinkControl() {
		return (EAttribute)dataLinkDataTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDataLinkDataType_IntegrityControl() {
		return (EAttribute)dataLinkDataTypeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDataLinkDataType_ReadPermission() {
		return (EAttribute)dataLinkDataTypeEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDataLinkDataType_WritePermission() {
		return (EAttribute)dataLinkDataTypeEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDataLinkDataType_Recovery() {
		return (EAttribute)dataLinkDataTypeEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDataLinkDataType_Unlink() {
		return (EAttribute)dataLinkDataTypeEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getUserDefinedTypeOrdering() {
		return userDefinedTypeOrderingEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getUserDefinedTypeOrdering_OrderingForm() {
		return (EAttribute)userDefinedTypeOrderingEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getUserDefinedTypeOrdering_OrderingCategory() {
		return (EAttribute)userDefinedTypeOrderingEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getUserDefinedTypeOrdering_OrderingRoutine() {
		return (EReference)userDefinedTypeOrderingEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDateDataType() {
		return dateDataTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getExactNumericDataType() {
		return exactNumericDataTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getExactNumericDataType_Scale() {
		return (EAttribute)exactNumericDataTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getApproximateNumericDataType() {
		return approximateNumericDataTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getIntegerDataType() {
		return integerDataTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getXMLDataType() {
		return xmlDataTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getCoercibilityType() {
		return coercibilityTypeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getIntervalQualifierType() {
		return intervalQualifierTypeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getOrderingType() {
		return orderingTypeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getOrderingCategoryType() {
		return orderingCategoryTypeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getPrimitiveType() {
		return primitiveTypeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getLinkControlOption() {
		return linkControlOptionEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getIntegrityControlOption() {
		return integrityControlOptionEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getReadPermissionOption() {
		return readPermissionOptionEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getWritePermissionOption() {
		return writePermissionOptionEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getUnlinkOption() {
		return unlinkOptionEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DatatypesFactory getDatatypesFactory() {
		return (DatatypesFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		userDefinedTypeEClass = createEClass(USER_DEFINED_TYPE);
		createEReference(userDefinedTypeEClass, USER_DEFINED_TYPE__SCHEMA);
		createEReference(userDefinedTypeEClass, USER_DEFINED_TYPE__ORDERING);

		dataTypeEClass = createEClass(DATA_TYPE);

		predefinedDataTypeEClass = createEClass(PREDEFINED_DATA_TYPE);
		createEAttribute(predefinedDataTypeEClass, PREDEFINED_DATA_TYPE__PRIMITIVE_TYPE);

		collectionDataTypeEClass = createEClass(COLLECTION_DATA_TYPE);
		createEReference(collectionDataTypeEClass, COLLECTION_DATA_TYPE__ELEMENT);

		numericalDataTypeEClass = createEClass(NUMERICAL_DATA_TYPE);
		createEAttribute(numericalDataTypeEClass, NUMERICAL_DATA_TYPE__PRECISION);

		characterStringDataTypeEClass = createEClass(CHARACTER_STRING_DATA_TYPE);
		createEAttribute(characterStringDataTypeEClass, CHARACTER_STRING_DATA_TYPE__LENGTH);
		createEAttribute(characterStringDataTypeEClass, CHARACTER_STRING_DATA_TYPE__COERCIBILITY);
		createEAttribute(characterStringDataTypeEClass, CHARACTER_STRING_DATA_TYPE__FIXED_LENGTH);
		createEAttribute(characterStringDataTypeEClass, CHARACTER_STRING_DATA_TYPE__COLLATION_NAME);
		createEReference(characterStringDataTypeEClass, CHARACTER_STRING_DATA_TYPE__CHARACTER_SET);

		rowDataTypeEClass = createEClass(ROW_DATA_TYPE);
		createEReference(rowDataTypeEClass, ROW_DATA_TYPE__FIELDS);

		arrayDataTypeEClass = createEClass(ARRAY_DATA_TYPE);
		createEAttribute(arrayDataTypeEClass, ARRAY_DATA_TYPE__MAX_CARDINALITY);

		multisetDataTypeEClass = createEClass(MULTISET_DATA_TYPE);

		booleanDataTypeEClass = createEClass(BOOLEAN_DATA_TYPE);

		intervalDataTypeEClass = createEClass(INTERVAL_DATA_TYPE);
		createEAttribute(intervalDataTypeEClass, INTERVAL_DATA_TYPE__LEADING_QUALIFIER);
		createEAttribute(intervalDataTypeEClass, INTERVAL_DATA_TYPE__TRAILING_QUALIFIER);
		createEAttribute(intervalDataTypeEClass, INTERVAL_DATA_TYPE__LEADING_FIELD_PRECISION);
		createEAttribute(intervalDataTypeEClass, INTERVAL_DATA_TYPE__TRAILING_FIELD_PRECISION);
		createEAttribute(intervalDataTypeEClass, INTERVAL_DATA_TYPE__FRACTIONAL_SECONDS_PRECISION);

		binaryStringDataTypeEClass = createEClass(BINARY_STRING_DATA_TYPE);
		createEAttribute(binaryStringDataTypeEClass, BINARY_STRING_DATA_TYPE__LENGTH);

		characterSetEClass = createEClass(CHARACTER_SET);
		createEAttribute(characterSetEClass, CHARACTER_SET__REPERTOIRE);
		createEAttribute(characterSetEClass, CHARACTER_SET__DEFAULT_COLLATION);
		createEAttribute(characterSetEClass, CHARACTER_SET__ENCODING);
		createEReference(characterSetEClass, CHARACTER_SET__SCHEMA);

		timeDataTypeEClass = createEClass(TIME_DATA_TYPE);
		createEAttribute(timeDataTypeEClass, TIME_DATA_TYPE__FRACTIONAL_SECONDS_PRECISION);
		createEAttribute(timeDataTypeEClass, TIME_DATA_TYPE__TIME_ZONE);

		distinctUserDefinedTypeEClass = createEClass(DISTINCT_USER_DEFINED_TYPE);
		createEReference(distinctUserDefinedTypeEClass, DISTINCT_USER_DEFINED_TYPE__PREDEFINED_REPRESENTATION);

		structuredUserDefinedTypeEClass = createEClass(STRUCTURED_USER_DEFINED_TYPE);
		createEAttribute(structuredUserDefinedTypeEClass, STRUCTURED_USER_DEFINED_TYPE__INSTANTIABLE);
		createEAttribute(structuredUserDefinedTypeEClass, STRUCTURED_USER_DEFINED_TYPE__FINAL);
		createEReference(structuredUserDefinedTypeEClass, STRUCTURED_USER_DEFINED_TYPE__SUPER);
		createEReference(structuredUserDefinedTypeEClass, STRUCTURED_USER_DEFINED_TYPE__SUB);
		createEReference(structuredUserDefinedTypeEClass, STRUCTURED_USER_DEFINED_TYPE__ATTRIBUTES);
		createEReference(structuredUserDefinedTypeEClass, STRUCTURED_USER_DEFINED_TYPE__METHODS);

		attributeDefinitionEClass = createEClass(ATTRIBUTE_DEFINITION);
		createEAttribute(attributeDefinitionEClass, ATTRIBUTE_DEFINITION__SCOPE_CHECK);
		createEAttribute(attributeDefinitionEClass, ATTRIBUTE_DEFINITION__SCOPE_CHECKED);
		createEAttribute(attributeDefinitionEClass, ATTRIBUTE_DEFINITION__DEFAULT_VALUE);

		fixedPrecisionDataTypeEClass = createEClass(FIXED_PRECISION_DATA_TYPE);

		domainEClass = createEClass(DOMAIN);
		createEReference(domainEClass, DOMAIN__CONSTRAINT);
		createEAttribute(domainEClass, DOMAIN__DEFAULT_VALUE);

		fieldEClass = createEClass(FIELD);
		createEAttribute(fieldEClass, FIELD__SCOPE_CHECK);
		createEAttribute(fieldEClass, FIELD__SCOPE_CHECKED);

		referenceDataTypeEClass = createEClass(REFERENCE_DATA_TYPE);
		createEReference(referenceDataTypeEClass, REFERENCE_DATA_TYPE__SCOPE_TABLE);
		createEReference(referenceDataTypeEClass, REFERENCE_DATA_TYPE__REFERENCED_TYPE);

		constructedDataTypeEClass = createEClass(CONSTRUCTED_DATA_TYPE);

		sqlDataTypeEClass = createEClass(SQL_DATA_TYPE);

		dataLinkDataTypeEClass = createEClass(DATA_LINK_DATA_TYPE);
		createEAttribute(dataLinkDataTypeEClass, DATA_LINK_DATA_TYPE__LENGTH);
		createEAttribute(dataLinkDataTypeEClass, DATA_LINK_DATA_TYPE__LINK_CONTROL);
		createEAttribute(dataLinkDataTypeEClass, DATA_LINK_DATA_TYPE__INTEGRITY_CONTROL);
		createEAttribute(dataLinkDataTypeEClass, DATA_LINK_DATA_TYPE__READ_PERMISSION);
		createEAttribute(dataLinkDataTypeEClass, DATA_LINK_DATA_TYPE__WRITE_PERMISSION);
		createEAttribute(dataLinkDataTypeEClass, DATA_LINK_DATA_TYPE__RECOVERY);
		createEAttribute(dataLinkDataTypeEClass, DATA_LINK_DATA_TYPE__UNLINK);

		userDefinedTypeOrderingEClass = createEClass(USER_DEFINED_TYPE_ORDERING);
		createEAttribute(userDefinedTypeOrderingEClass, USER_DEFINED_TYPE_ORDERING__ORDERING_FORM);
		createEAttribute(userDefinedTypeOrderingEClass, USER_DEFINED_TYPE_ORDERING__ORDERING_CATEGORY);
		createEReference(userDefinedTypeOrderingEClass, USER_DEFINED_TYPE_ORDERING__ORDERING_ROUTINE);

		dateDataTypeEClass = createEClass(DATE_DATA_TYPE);

		exactNumericDataTypeEClass = createEClass(EXACT_NUMERIC_DATA_TYPE);
		createEAttribute(exactNumericDataTypeEClass, EXACT_NUMERIC_DATA_TYPE__SCALE);

		approximateNumericDataTypeEClass = createEClass(APPROXIMATE_NUMERIC_DATA_TYPE);

		integerDataTypeEClass = createEClass(INTEGER_DATA_TYPE);

		xmlDataTypeEClass = createEClass(XML_DATA_TYPE);

		// Create enums
		coercibilityTypeEEnum = createEEnum(COERCIBILITY_TYPE);
		intervalQualifierTypeEEnum = createEEnum(INTERVAL_QUALIFIER_TYPE);
		orderingTypeEEnum = createEEnum(ORDERING_TYPE);
		orderingCategoryTypeEEnum = createEEnum(ORDERING_CATEGORY_TYPE);
		primitiveTypeEEnum = createEEnum(PRIMITIVE_TYPE);
		linkControlOptionEEnum = createEEnum(LINK_CONTROL_OPTION);
		integrityControlOptionEEnum = createEEnum(INTEGRITY_CONTROL_OPTION);
		readPermissionOptionEEnum = createEEnum(READ_PERMISSION_OPTION);
		writePermissionOptionEEnum = createEEnum(WRITE_PERMISSION_OPTION);
		unlinkOptionEEnum = createEEnum(UNLINK_OPTION);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		SchemaPackage theSchemaPackage = (SchemaPackage)EPackage.Registry.INSTANCE.getEPackage(SchemaPackage.eNS_URI);
		RoutinesPackage theRoutinesPackage = (RoutinesPackage)EPackage.Registry.INSTANCE.getEPackage(RoutinesPackage.eNS_URI);
		ConstraintsPackage theConstraintsPackage = (ConstraintsPackage)EPackage.Registry.INSTANCE.getEPackage(ConstraintsPackage.eNS_URI);
		TablesPackage theTablesPackage = (TablesPackage)EPackage.Registry.INSTANCE.getEPackage(TablesPackage.eNS_URI);

		// Create type parameters

		// Set bounds for type parameters

		// Add supertypes to classes
		userDefinedTypeEClass.getESuperTypes().add(this.getDataType());
		dataTypeEClass.getESuperTypes().add(theSchemaPackage.getSQLObject());
		predefinedDataTypeEClass.getESuperTypes().add(this.getSQLDataType());
		collectionDataTypeEClass.getESuperTypes().add(this.getConstructedDataType());
		numericalDataTypeEClass.getESuperTypes().add(this.getPredefinedDataType());
		characterStringDataTypeEClass.getESuperTypes().add(this.getPredefinedDataType());
		rowDataTypeEClass.getESuperTypes().add(this.getConstructedDataType());
		arrayDataTypeEClass.getESuperTypes().add(this.getCollectionDataType());
		multisetDataTypeEClass.getESuperTypes().add(this.getCollectionDataType());
		booleanDataTypeEClass.getESuperTypes().add(this.getPredefinedDataType());
		intervalDataTypeEClass.getESuperTypes().add(this.getPredefinedDataType());
		binaryStringDataTypeEClass.getESuperTypes().add(this.getPredefinedDataType());
		characterSetEClass.getESuperTypes().add(theSchemaPackage.getSQLObject());
		timeDataTypeEClass.getESuperTypes().add(this.getPredefinedDataType());
		distinctUserDefinedTypeEClass.getESuperTypes().add(this.getUserDefinedType());
		structuredUserDefinedTypeEClass.getESuperTypes().add(this.getUserDefinedType());
		attributeDefinitionEClass.getESuperTypes().add(theSchemaPackage.getTypedElement());
		fixedPrecisionDataTypeEClass.getESuperTypes().add(this.getExactNumericDataType());
		domainEClass.getESuperTypes().add(this.getDistinctUserDefinedType());
		fieldEClass.getESuperTypes().add(theSchemaPackage.getTypedElement());
		referenceDataTypeEClass.getESuperTypes().add(this.getConstructedDataType());
		constructedDataTypeEClass.getESuperTypes().add(this.getSQLDataType());
		sqlDataTypeEClass.getESuperTypes().add(this.getDataType());
		dataLinkDataTypeEClass.getESuperTypes().add(this.getPredefinedDataType());
		userDefinedTypeOrderingEClass.getESuperTypes().add(theSchemaPackage.getSQLObject());
		dateDataTypeEClass.getESuperTypes().add(this.getPredefinedDataType());
		exactNumericDataTypeEClass.getESuperTypes().add(this.getNumericalDataType());
		approximateNumericDataTypeEClass.getESuperTypes().add(this.getNumericalDataType());
		integerDataTypeEClass.getESuperTypes().add(this.getExactNumericDataType());
		xmlDataTypeEClass.getESuperTypes().add(this.getPredefinedDataType());

		// Initialize classes and features; add operations and parameters
		initEClass(userDefinedTypeEClass, UserDefinedType.class, "UserDefinedType", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getUserDefinedType_Schema(), theSchemaPackage.getSchema(), theSchemaPackage.getSchema_UserDefinedTypes(), "schema", null, 1, 1, UserDefinedType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getUserDefinedType_Ordering(), this.getUserDefinedTypeOrdering(), null, "ordering", null, 0, 1, UserDefinedType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(dataTypeEClass, DataType.class, "DataType", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		EOperation op = addEOperation(dataTypeEClass, null, "setContainer", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theSchemaPackage.getTypedElement(), "newContainer", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(predefinedDataTypeEClass, PredefinedDataType.class, "PredefinedDataType", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getPredefinedDataType_PrimitiveType(), this.getPrimitiveType(), "primitiveType", null, 0, 1, PredefinedDataType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(collectionDataTypeEClass, CollectionDataType.class, "CollectionDataType", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getCollectionDataType_Element(), this.getDataType(), null, "element", null, 1, -1, CollectionDataType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(numericalDataTypeEClass, NumericalDataType.class, "NumericalDataType", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getNumericalDataType_Precision(), ecorePackage.getEInt(), "precision", null, 0, 1, NumericalDataType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(characterStringDataTypeEClass, CharacterStringDataType.class, "CharacterStringDataType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCharacterStringDataType_Length(), ecorePackage.getEInt(), "length", "1", 0, 1, CharacterStringDataType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCharacterStringDataType_Coercibility(), this.getCoercibilityType(), "coercibility", null, 0, 1, CharacterStringDataType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCharacterStringDataType_FixedLength(), ecorePackage.getEBoolean(), "fixedLength", null, 0, 1, CharacterStringDataType.class, !IS_TRANSIENT, !IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCharacterStringDataType_CollationName(), ecorePackage.getEString(), "collationName", null, 0, 1, CharacterStringDataType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getCharacterStringDataType_CharacterSet(), this.getCharacterSet(), null, "characterSet", null, 1, 1, CharacterStringDataType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(rowDataTypeEClass, RowDataType.class, "RowDataType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getRowDataType_Fields(), this.getField(), null, "fields", null, 1, -1, RowDataType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(arrayDataTypeEClass, ArrayDataType.class, "ArrayDataType", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getArrayDataType_MaxCardinality(), ecorePackage.getEInt(), "maxCardinality", null, 0, 1, ArrayDataType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(multisetDataTypeEClass, MultisetDataType.class, "MultisetDataType", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(booleanDataTypeEClass, BooleanDataType.class, "BooleanDataType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(intervalDataTypeEClass, IntervalDataType.class, "IntervalDataType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getIntervalDataType_LeadingQualifier(), this.getIntervalQualifierType(), "leadingQualifier", null, 0, 1, IntervalDataType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getIntervalDataType_TrailingQualifier(), this.getIntervalQualifierType(), "trailingQualifier", null, 0, 1, IntervalDataType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getIntervalDataType_LeadingFieldPrecision(), ecorePackage.getEInt(), "leadingFieldPrecision", null, 0, 1, IntervalDataType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getIntervalDataType_TrailingFieldPrecision(), ecorePackage.getEInt(), "trailingFieldPrecision", null, 0, 1, IntervalDataType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getIntervalDataType_FractionalSecondsPrecision(), ecorePackage.getEInt(), "fractionalSecondsPrecision", null, 0, 1, IntervalDataType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(binaryStringDataTypeEClass, BinaryStringDataType.class, "BinaryStringDataType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getBinaryStringDataType_Length(), ecorePackage.getEInt(), "length", null, 0, 1, BinaryStringDataType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		addEOperation(binaryStringDataTypeEClass, ecorePackage.getEBoolean(), "equals", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(characterSetEClass, CharacterSet.class, "CharacterSet", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCharacterSet_Repertoire(), ecorePackage.getEString(), "repertoire", null, 0, 1, CharacterSet.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCharacterSet_DefaultCollation(), ecorePackage.getEString(), "defaultCollation", null, 0, 1, CharacterSet.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCharacterSet_Encoding(), ecorePackage.getEString(), "encoding", null, 0, 1, CharacterSet.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getCharacterSet_Schema(), theSchemaPackage.getSchema(), theSchemaPackage.getSchema_CharSets(), "schema", null, 1, 1, CharacterSet.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(timeDataTypeEClass, TimeDataType.class, "TimeDataType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTimeDataType_FractionalSecondsPrecision(), ecorePackage.getEInt(), "fractionalSecondsPrecision", null, 0, 1, TimeDataType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTimeDataType_TimeZone(), ecorePackage.getEBoolean(), "timeZone", "false", 0, 1, TimeDataType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(distinctUserDefinedTypeEClass, DistinctUserDefinedType.class, "DistinctUserDefinedType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getDistinctUserDefinedType_PredefinedRepresentation(), this.getPredefinedDataType(), null, "predefinedRepresentation", null, 1, 1, DistinctUserDefinedType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(structuredUserDefinedTypeEClass, StructuredUserDefinedType.class, "StructuredUserDefinedType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getStructuredUserDefinedType_Instantiable(), ecorePackage.getEBoolean(), "instantiable", "True", 0, 1, StructuredUserDefinedType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getStructuredUserDefinedType_Final(), ecorePackage.getEBoolean(), "final", null, 0, 1, StructuredUserDefinedType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getStructuredUserDefinedType_Super(), this.getStructuredUserDefinedType(), this.getStructuredUserDefinedType_Sub(), "super", null, 0, 1, StructuredUserDefinedType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getStructuredUserDefinedType_Sub(), this.getStructuredUserDefinedType(), this.getStructuredUserDefinedType_Super(), "sub", null, 0, -1, StructuredUserDefinedType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getStructuredUserDefinedType_Attributes(), this.getAttributeDefinition(), null, "attributes", null, 0, -1, StructuredUserDefinedType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getStructuredUserDefinedType_Methods(), theRoutinesPackage.getMethod(), null, "methods", null, 0, -1, StructuredUserDefinedType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(attributeDefinitionEClass, AttributeDefinition.class, "AttributeDefinition", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getAttributeDefinition_ScopeCheck(), theSchemaPackage.getReferentialActionType(), "scopeCheck", null, 0, 1, AttributeDefinition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getAttributeDefinition_ScopeChecked(), ecorePackage.getEBoolean(), "scopeChecked", null, 0, 1, AttributeDefinition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getAttributeDefinition_DefaultValue(), ecorePackage.getEString(), "defaultValue", null, 0, 1, AttributeDefinition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(fixedPrecisionDataTypeEClass, FixedPrecisionDataType.class, "FixedPrecisionDataType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(domainEClass, Domain.class, "Domain", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getDomain_Constraint(), theConstraintsPackage.getCheckConstraint(), null, "constraint", null, 0, -1, Domain.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDomain_DefaultValue(), ecorePackage.getEString(), "defaultValue", null, 0, 1, Domain.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(fieldEClass, Field.class, "Field", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getField_ScopeCheck(), theSchemaPackage.getReferentialActionType(), "scopeCheck", null, 0, 1, Field.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getField_ScopeChecked(), ecorePackage.getEBoolean(), "scopeChecked", null, 0, 1, Field.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(referenceDataTypeEClass, ReferenceDataType.class, "ReferenceDataType", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getReferenceDataType_ScopeTable(), theTablesPackage.getTable(), null, "scopeTable", null, 1, 1, ReferenceDataType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getReferenceDataType_ReferencedType(), this.getStructuredUserDefinedType(), null, "referencedType", null, 1, 1, ReferenceDataType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(constructedDataTypeEClass, ConstructedDataType.class, "ConstructedDataType", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(sqlDataTypeEClass, SQLDataType.class, "SQLDataType", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(dataLinkDataTypeEClass, DataLinkDataType.class, "DataLinkDataType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getDataLinkDataType_Length(), ecorePackage.getEInt(), "length", null, 0, 1, DataLinkDataType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDataLinkDataType_LinkControl(), this.getLinkControlOption(), "linkControl", null, 0, 1, DataLinkDataType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDataLinkDataType_IntegrityControl(), this.getIntegrityControlOption(), "integrityControl", null, 0, 1, DataLinkDataType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDataLinkDataType_ReadPermission(), this.getReadPermissionOption(), "readPermission", null, 0, 1, DataLinkDataType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDataLinkDataType_WritePermission(), this.getWritePermissionOption(), "writePermission", null, 0, 1, DataLinkDataType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDataLinkDataType_Recovery(), ecorePackage.getEBoolean(), "recovery", null, 0, 1, DataLinkDataType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDataLinkDataType_Unlink(), this.getUnlinkOption(), "unlink", null, 0, 1, DataLinkDataType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(userDefinedTypeOrderingEClass, UserDefinedTypeOrdering.class, "UserDefinedTypeOrdering", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getUserDefinedTypeOrdering_OrderingForm(), this.getOrderingType(), "orderingForm", null, 0, 1, UserDefinedTypeOrdering.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getUserDefinedTypeOrdering_OrderingCategory(), this.getOrderingCategoryType(), "orderingCategory", null, 0, 1, UserDefinedTypeOrdering.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getUserDefinedTypeOrdering_OrderingRoutine(), theRoutinesPackage.getRoutine(), null, "orderingRoutine", null, 1, 1, UserDefinedTypeOrdering.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(dateDataTypeEClass, DateDataType.class, "DateDataType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(exactNumericDataTypeEClass, ExactNumericDataType.class, "ExactNumericDataType", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getExactNumericDataType_Scale(), ecorePackage.getEInt(), "scale", null, 0, 1, ExactNumericDataType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(approximateNumericDataTypeEClass, ApproximateNumericDataType.class, "ApproximateNumericDataType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(integerDataTypeEClass, IntegerDataType.class, "IntegerDataType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(xmlDataTypeEClass, XMLDataType.class, "XMLDataType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		// Initialize enums and add enum literals
		initEEnum(coercibilityTypeEEnum, CoercibilityType.class, "CoercibilityType");
		addEEnumLiteral(coercibilityTypeEEnum, CoercibilityType.IMPLICIT);
		addEEnumLiteral(coercibilityTypeEEnum, CoercibilityType.EXPLICIT);
		addEEnumLiteral(coercibilityTypeEEnum, CoercibilityType.COERCIBILE);
		addEEnumLiteral(coercibilityTypeEEnum, CoercibilityType.NO_COLLATION);

		initEEnum(intervalQualifierTypeEEnum, IntervalQualifierType.class, "IntervalQualifierType");
		addEEnumLiteral(intervalQualifierTypeEEnum, IntervalQualifierType.YEAR);
		addEEnumLiteral(intervalQualifierTypeEEnum, IntervalQualifierType.MONTH);
		addEEnumLiteral(intervalQualifierTypeEEnum, IntervalQualifierType.DAY);
		addEEnumLiteral(intervalQualifierTypeEEnum, IntervalQualifierType.HOUR);
		addEEnumLiteral(intervalQualifierTypeEEnum, IntervalQualifierType.MINUTE);
		addEEnumLiteral(intervalQualifierTypeEEnum, IntervalQualifierType.SECOND);
		addEEnumLiteral(intervalQualifierTypeEEnum, IntervalQualifierType.FRACTION);

		initEEnum(orderingTypeEEnum, OrderingType.class, "OrderingType");
		addEEnumLiteral(orderingTypeEEnum, OrderingType.EQUALS);
		addEEnumLiteral(orderingTypeEEnum, OrderingType.FULL);

		initEEnum(orderingCategoryTypeEEnum, OrderingCategoryType.class, "OrderingCategoryType");
		addEEnumLiteral(orderingCategoryTypeEEnum, OrderingCategoryType.RELATIVE);
		addEEnumLiteral(orderingCategoryTypeEEnum, OrderingCategoryType.MAP);
		addEEnumLiteral(orderingCategoryTypeEEnum, OrderingCategoryType.STATE);

		initEEnum(primitiveTypeEEnum, PrimitiveType.class, "PrimitiveType");
		addEEnumLiteral(primitiveTypeEEnum, PrimitiveType.CHARACTER);
		addEEnumLiteral(primitiveTypeEEnum, PrimitiveType.CHARACTER_VARYING);
		addEEnumLiteral(primitiveTypeEEnum, PrimitiveType.CHARACTER_LARGE_OBJECT);
		addEEnumLiteral(primitiveTypeEEnum, PrimitiveType.NATIONAL_CHARACTER);
		addEEnumLiteral(primitiveTypeEEnum, PrimitiveType.NATIONAL_CHARACTER_VARYING);
		addEEnumLiteral(primitiveTypeEEnum, PrimitiveType.NATIONAL_CHARACTER_LARGE_OBJECT);
		addEEnumLiteral(primitiveTypeEEnum, PrimitiveType.BINARY);
		addEEnumLiteral(primitiveTypeEEnum, PrimitiveType.BINARY_VARYING);
		addEEnumLiteral(primitiveTypeEEnum, PrimitiveType.BINARY_LARGE_OBJECT);
		addEEnumLiteral(primitiveTypeEEnum, PrimitiveType.NUMERIC);
		addEEnumLiteral(primitiveTypeEEnum, PrimitiveType.DECIMAL);
		addEEnumLiteral(primitiveTypeEEnum, PrimitiveType.SMALLINT);
		addEEnumLiteral(primitiveTypeEEnum, PrimitiveType.INTEGER);
		addEEnumLiteral(primitiveTypeEEnum, PrimitiveType.BIGINT);
		addEEnumLiteral(primitiveTypeEEnum, PrimitiveType.FLOAT);
		addEEnumLiteral(primitiveTypeEEnum, PrimitiveType.REAL);
		addEEnumLiteral(primitiveTypeEEnum, PrimitiveType.DOUBLE_PRECISION);
		addEEnumLiteral(primitiveTypeEEnum, PrimitiveType.BOOLEAN);
		addEEnumLiteral(primitiveTypeEEnum, PrimitiveType.DATE);
		addEEnumLiteral(primitiveTypeEEnum, PrimitiveType.TIME);
		addEEnumLiteral(primitiveTypeEEnum, PrimitiveType.TIMESTAMP);
		addEEnumLiteral(primitiveTypeEEnum, PrimitiveType.INTERVAL);
		addEEnumLiteral(primitiveTypeEEnum, PrimitiveType.DATALINK);
		addEEnumLiteral(primitiveTypeEEnum, PrimitiveType.XML_TYPE);

		initEEnum(linkControlOptionEEnum, LinkControlOption.class, "LinkControlOption");
		addEEnumLiteral(linkControlOptionEEnum, LinkControlOption.FILE_LINK_CONTROL);
		addEEnumLiteral(linkControlOptionEEnum, LinkControlOption.NO_FILE_LINK_CONTROL);

		initEEnum(integrityControlOptionEEnum, IntegrityControlOption.class, "IntegrityControlOption");
		addEEnumLiteral(integrityControlOptionEEnum, IntegrityControlOption.ALL);
		addEEnumLiteral(integrityControlOptionEEnum, IntegrityControlOption.SELECTIVE);
		addEEnumLiteral(integrityControlOptionEEnum, IntegrityControlOption.NONE);

		initEEnum(readPermissionOptionEEnum, ReadPermissionOption.class, "ReadPermissionOption");
		addEEnumLiteral(readPermissionOptionEEnum, ReadPermissionOption.FS);
		addEEnumLiteral(readPermissionOptionEEnum, ReadPermissionOption.DB);

		initEEnum(writePermissionOptionEEnum, WritePermissionOption.class, "WritePermissionOption");
		addEEnumLiteral(writePermissionOptionEEnum, WritePermissionOption.FS);
		addEEnumLiteral(writePermissionOptionEEnum, WritePermissionOption.ADMIN);
		addEEnumLiteral(writePermissionOptionEEnum, WritePermissionOption.BLOCKED);

		initEEnum(unlinkOptionEEnum, UnlinkOption.class, "UnlinkOption");
		addEEnumLiteral(unlinkOptionEEnum, UnlinkOption.RESTORE);
		addEEnumLiteral(unlinkOptionEEnum, UnlinkOption.DELETE);
		addEEnumLiteral(unlinkOptionEEnum, UnlinkOption.NONE);

		// Create resource
		createResource(eNS_URI);
	}

} //DatatypesPackageImpl
