package de.fhtw.dataprofiler.sqlmodel.diagram.edit.commands;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.type.core.commands.CreateElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.ConfigureRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateRelationshipRequest;

import de.fhtw.dataprofiler.sqlmodel.constraints.ConstraintsFactory;
import de.fhtw.dataprofiler.sqlmodel.constraints.ForeignKey;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.policies.SqlmodelBaseItemSemanticEditPolicy;
import de.fhtw.dataprofiler.sqlmodel.tables.BaseTable;
import de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage;

/**
 * @generated
 */
public class ForeignKeyCreateCommand extends CreateElementCommand {

	/**
	 * @generated
	 */
	private final EObject source;

	/**
	 * @generated
	 */
	private final EObject target;

	/**
	 * @generated
	 */
	private BaseTable container;

	/**
	 * @generated
	 */
	public ForeignKeyCreateCommand(CreateRelationshipRequest request, EObject source, EObject target) {
		super(request);
		this.source = source;
		this.target = target;
		if (request.getContainmentFeature() == null) {
			setContainmentFeature(TablesPackage.eINSTANCE.getBaseTable_Constraints());
		}

		// Find container element for the new link.
		// Climb up by containment hierarchy starting from the source
		// and return the first element that is instance of the container class.
		for (EObject element = source; element != null; element = element.eContainer()) {
			if (element instanceof BaseTable) {
				container = (BaseTable) element;
				super.setElementToEdit(container);
				break;
			}
		}
	}

	/**
	 * @generated
	 */
	public boolean canExecute() {
		if (source == null && target == null) {
			return false;
		}
		if (source != null && !(source instanceof BaseTable)) {
			return false;
		}
		if (target != null && !(target instanceof BaseTable)) {
			return false;
		}
		if (getSource() == null) {
			return true; // link creation is in progress; source is not defined yet
		}
		// target may be null here but it's possible to check constraint
		if (getContainer() == null) {
			return false;
		}
		return SqlmodelBaseItemSemanticEditPolicy.LinkConstraints.canCreateForeignKey_3001(getContainer(), getSource(),
				getTarget());
	}

	/**
	 * @generated
	 */
	protected EObject doDefaultElementCreation() {
		// de.fhtw.dataprofiler.sqlmodel.constraints.ForeignKey newElement = (de.fhtw.dataprofiler.sqlmodel.constraints.ForeignKey) super.doDefaultElementCreation();
		ForeignKey newElement = ConstraintsFactory.eINSTANCE.createForeignKey();
		getContainer().getConstraints().add(newElement);
		newElement.setBaseTable(getSource());
		newElement.setReferencedTable(getTarget());
		return newElement;
	}

	/**
	 * @generated
	 */
	protected EClass getEClassToEdit() {
		return TablesPackage.eINSTANCE.getBaseTable();
	}

	/**
	 * @generated
	 */
	protected CommandResult doExecuteWithResult(IProgressMonitor monitor, IAdaptable info) throws ExecutionException {
		if (!canExecute()) {
			throw new ExecutionException("Invalid arguments in create link command"); //$NON-NLS-1$
		}
		return super.doExecuteWithResult(monitor, info);
	}

	/**
	 * @generated
	 */
	protected ConfigureRequest createConfigureRequest() {
		ConfigureRequest request = super.createConfigureRequest();
		request.setParameter(CreateRelationshipRequest.SOURCE, getSource());
		request.setParameter(CreateRelationshipRequest.TARGET, getTarget());
		return request;
	}

	/**
	 * @generated
	 */
	protected void setElementToEdit(EObject element) {
		throw new UnsupportedOperationException();
	}

	/**
	 * @generated
	 */
	protected BaseTable getSource() {
		return (BaseTable) source;
	}

	/**
	 * @generated
	 */
	protected BaseTable getTarget() {
		return (BaseTable) target;
	}

	/**
	 * @generated
	 */
	public BaseTable getContainer() {
		return container;
	}
}
