package de.fhtw.dataprofiler.sqlmodel.diagram.edit.commands;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.type.core.commands.EditElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;

import de.fhtw.dataprofiler.sqlmodel.constraints.ForeignKey;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.policies.SqlmodelBaseItemSemanticEditPolicy;
import de.fhtw.dataprofiler.sqlmodel.tables.BaseTable;

/**
 * @generated
 */
public class ForeignKeyReorientCommand extends EditElementCommand {

	/**
	 * @generated
	 */
	private final int reorientDirection;

	/**
	 * @generated
	 */
	private final EObject oldEnd;

	/**
	 * @generated
	 */
	private final EObject newEnd;

	/**
	 * @generated
	 */
	public ForeignKeyReorientCommand(ReorientRelationshipRequest request) {
		super(request.getLabel(), request.getRelationship(), request);
		reorientDirection = request.getDirection();
		oldEnd = request.getOldRelationshipEnd();
		newEnd = request.getNewRelationshipEnd();
	}

	/**
	 * @generated
	 */
	public boolean canExecute() {
		if (!(getElementToEdit() instanceof ForeignKey)) {
			return false;
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return canReorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return canReorientTarget();
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean canReorientSource() {
		if (!(oldEnd instanceof BaseTable && newEnd instanceof BaseTable)) {
			return false;
		}
		BaseTable target = getLink().getReferencedTable();
		if (!(getLink().eContainer() instanceof BaseTable)) {
			return false;
		}
		BaseTable container = (BaseTable) getLink().eContainer();
		return SqlmodelBaseItemSemanticEditPolicy.LinkConstraints.canExistForeignKey_3001(container, getNewSource(),
				target);
	}

	/**
	 * @generated
	 */
	protected boolean canReorientTarget() {
		if (!(oldEnd instanceof BaseTable && newEnd instanceof BaseTable)) {
			return false;
		}
		BaseTable source = getLink().getBaseTable();
		if (!(getLink().eContainer() instanceof BaseTable)) {
			return false;
		}
		BaseTable container = (BaseTable) getLink().eContainer();
		return SqlmodelBaseItemSemanticEditPolicy.LinkConstraints.canExistForeignKey_3001(container, source,
				getNewTarget());
	}

	/**
	 * @generated
	 */
	protected CommandResult doExecuteWithResult(IProgressMonitor monitor, IAdaptable info) throws ExecutionException {
		if (!canExecute()) {
			throw new ExecutionException("Invalid arguments in reorient link command"); //$NON-NLS-1$
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return reorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return reorientTarget();
		}
		throw new IllegalStateException();
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientSource() throws ExecutionException {
		getLink().setBaseTable(getNewSource());
		return CommandResult.newOKCommandResult(getLink());
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientTarget() throws ExecutionException {
		getLink().setReferencedTable(getNewTarget());
		return CommandResult.newOKCommandResult(getLink());
	}

	/**
	 * @generated
	 */
	protected ForeignKey getLink() {
		return (ForeignKey) getElementToEdit();
	}

	/**
	 * @generated
	 */
	protected BaseTable getOldSource() {
		return (BaseTable) oldEnd;
	}

	/**
	 * @generated
	 */
	protected BaseTable getNewSource() {
		return (BaseTable) newEnd;
	}

	/**
	 * @generated
	 */
	protected BaseTable getOldTarget() {
		return (BaseTable) oldEnd;
	}

	/**
	 * @generated
	 */
	protected BaseTable getNewTarget() {
		return (BaseTable) newEnd;
	}
}
