package de.fhtw.dataprofiler.sqlmodel.diagram.navigator;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserOptions;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserService;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.jface.viewers.ITreePathLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TreePath;
import org.eclipse.jface.viewers.ViewerLabel;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonLabelProvider;

import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.Column2EditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.ColumnEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.ForeignKeyEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.ForeignKeyNameEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.PersistentTableEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.PersistentTableNameEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.PrimaryKeyEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.SchemaEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.WrapLabelEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.part.SqlmodelDiagramEditorPlugin;
import de.fhtw.dataprofiler.sqlmodel.diagram.part.SqlmodelVisualIDRegistry;
import de.fhtw.dataprofiler.sqlmodel.diagram.providers.SqlmodelElementTypes;
import de.fhtw.dataprofiler.sqlmodel.diagram.providers.SqlmodelParserProvider;
import de.fhtw.dataprofiler.sqlmodel.schema.Schema;

/**
 * @generated
 */
public class SqlmodelNavigatorLabelProvider extends LabelProvider implements ICommonLabelProvider,
		ITreePathLabelProvider {

	/**
	 * @generated
	 */
	static {
		SqlmodelDiagramEditorPlugin.getInstance().getImageRegistry().put(
				"Navigator?UnknownElement", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
		SqlmodelDiagramEditorPlugin.getInstance().getImageRegistry().put(
				"Navigator?ImageNotFound", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	public void updateLabel(ViewerLabel label, TreePath elementPath) {
		Object element = elementPath.getLastSegment();
		if (element instanceof SqlmodelNavigatorItem && !isOwnView(((SqlmodelNavigatorItem) element).getView())) {
			return;
		}
		label.setText(getText(element));
		label.setImage(getImage(element));
	}

	/**
	 * @generated
	 */
	public Image getImage(Object element) {
		if (element instanceof SqlmodelNavigatorGroup) {
			SqlmodelNavigatorGroup group = (SqlmodelNavigatorGroup) element;
			return SqlmodelDiagramEditorPlugin.getInstance().getBundledImage(group.getIcon());
		}

		if (element instanceof SqlmodelNavigatorItem) {
			SqlmodelNavigatorItem navigatorItem = (SqlmodelNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return super.getImage(element);
			}
			return getImage(navigatorItem.getView());
		}

		return super.getImage(element);
	}

	/**
	 * @generated
	 */
	public Image getImage(View view) {
		switch (SqlmodelVisualIDRegistry.getVisualID(view)) {
		case SchemaEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Diagram?http:///org/eclipse/datatools/modelbase/sql/schema.ecore?Schema", SqlmodelElementTypes.Schema_79); //$NON-NLS-1$
		case PersistentTableEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http:///org/eclipse/datatools/modelbase/sql/tables.ecore?PersistentTable", SqlmodelElementTypes.PersistentTable_1001); //$NON-NLS-1$
		case ColumnEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http:///org/eclipse/datatools/modelbase/sql/tables.ecore?Column", SqlmodelElementTypes.Column_2001); //$NON-NLS-1$
		case PrimaryKeyEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http:///org/eclipse/datatools/modelbase/sql/constraints.ecore?PrimaryKey", SqlmodelElementTypes.PrimaryKey_2002); //$NON-NLS-1$
		case Column2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http:///org/eclipse/datatools/modelbase/sql/tables.ecore?Column", SqlmodelElementTypes.Column_2003); //$NON-NLS-1$
		case ForeignKeyEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http:///org/eclipse/datatools/modelbase/sql/constraints.ecore?ForeignKey", SqlmodelElementTypes.ForeignKey_3001); //$NON-NLS-1$
		}
		return getImage("Navigator?UnknownElement", null); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private Image getImage(String key, IElementType elementType) {
		ImageRegistry imageRegistry = SqlmodelDiagramEditorPlugin.getInstance().getImageRegistry();
		Image image = imageRegistry.get(key);
		if (image == null && elementType != null && SqlmodelElementTypes.isKnownElementType(elementType)) {
			image = SqlmodelElementTypes.getImage(elementType);
			imageRegistry.put(key, image);
		}

		if (image == null) {
			image = imageRegistry.get("Navigator?ImageNotFound"); //$NON-NLS-1$
			imageRegistry.put(key, image);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public String getText(Object element) {
		if (element instanceof SqlmodelNavigatorGroup) {
			SqlmodelNavigatorGroup group = (SqlmodelNavigatorGroup) element;
			return group.getGroupName();
		}

		if (element instanceof SqlmodelNavigatorItem) {
			SqlmodelNavigatorItem navigatorItem = (SqlmodelNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return null;
			}
			return getText(navigatorItem.getView());
		}

		return super.getText(element);
	}

	/**
	 * @generated
	 */
	public String getText(View view) {
		if (view.getElement() != null && view.getElement().eIsProxy()) {
			return getUnresolvedDomainElementProxyText(view);
		}
		switch (SqlmodelVisualIDRegistry.getVisualID(view)) {
		case SchemaEditPart.VISUAL_ID:
			return getSchema_79Text(view);
		case PersistentTableEditPart.VISUAL_ID:
			return getPersistentTable_1001Text(view);
		case ColumnEditPart.VISUAL_ID:
			return getColumn_2001Text(view);
		case PrimaryKeyEditPart.VISUAL_ID:
			return getPrimaryKey_2002Text(view);
		case Column2EditPart.VISUAL_ID:
			return getColumn_2003Text(view);
		case ForeignKeyEditPart.VISUAL_ID:
			return getForeignKey_3001Text(view);
		}
		return getUnknownElementText(view);
	}

	/**
	 * @generated
	 */
	private String getSchema_79Text(View view) {
		Schema domainModelElement = (Schema) view.getElement();
		if (domainModelElement != null) {
			return domainModelElement.getName();
		} else {
			SqlmodelDiagramEditorPlugin.getInstance().logError("No domain element for view with visualID = " + 79); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getPersistentTable_1001Text(View view) {
		IAdaptable hintAdapter = new SqlmodelParserProvider.HintAdapter(SqlmodelElementTypes.PersistentTable_1001,
				(view.getElement() != null ? view.getElement() : view), SqlmodelVisualIDRegistry
						.getType(PersistentTableNameEditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE.intValue());
		} else {
			SqlmodelDiagramEditorPlugin.getInstance().logError("Parser was not found for label " + 4002); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getColumn_2001Text(View view) {
		IAdaptable hintAdapter = new SqlmodelParserProvider.HintAdapter(SqlmodelElementTypes.Column_2001, (view
				.getElement() != null ? view.getElement() : view), SqlmodelVisualIDRegistry
				.getType(ColumnEditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE.intValue());
		} else {
			SqlmodelDiagramEditorPlugin.getInstance().logError("Parser was not found for label " + 2001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getPrimaryKey_2002Text(View view) {

		IAdaptable hintAdapter = new SqlmodelParserProvider.HintAdapter(SqlmodelElementTypes.PrimaryKey_2002, (view
				.getElement() != null ? view.getElement() : view), SqlmodelVisualIDRegistry
				.getType(WrapLabelEditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);
		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE.intValue());
		} else {
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getColumn_2003Text(View view) {
		IAdaptable hintAdapter = new SqlmodelParserProvider.HintAdapter(SqlmodelElementTypes.Column_2003, (view
				.getElement() != null ? view.getElement() : view), SqlmodelVisualIDRegistry
				.getType(Column2EditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE.intValue());
		} else {
			SqlmodelDiagramEditorPlugin.getInstance().logError("Parser was not found for label " + 2003); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getForeignKey_3001Text(View view) {
		IAdaptable hintAdapter = new SqlmodelParserProvider.HintAdapter(SqlmodelElementTypes.ForeignKey_3001, (view
				.getElement() != null ? view.getElement() : view), SqlmodelVisualIDRegistry
				.getType(ForeignKeyNameEditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE.intValue());
		} else {
			SqlmodelDiagramEditorPlugin.getInstance().logError("Parser was not found for label " + 4003); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getUnknownElementText(View view) {
		return "<UnknownElement Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$ //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	private String getUnresolvedDomainElementProxyText(View view) {
		return "<Unresolved domain element Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$ //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public String getDescription(Object anElement) {
		return null;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return SchemaEditPart.MODEL_ID.equals(SqlmodelVisualIDRegistry.getModelID(view));
	}

}
