package de.fhtw.dataprofiler.sqlmodel.diagram.part;

import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.gmf.runtime.notation.View;

import de.fhtw.dataprofiler.sqlmodel.constraints.ConstraintsPackage;
import de.fhtw.dataprofiler.sqlmodel.constraints.ForeignKey;
import de.fhtw.dataprofiler.sqlmodel.constraints.PrimaryKey;
import de.fhtw.dataprofiler.sqlmodel.constraints.TableConstraint;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.Column2EditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.ColumnEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.ForeignKeyEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.PersistentTableColumnsCompartmentEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.PersistentTableEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.PrimaryKeyEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.PrimaryKeyPrimaryKeyColumnsCompartmentEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.SchemaEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.providers.SqlmodelElementTypes;
import de.fhtw.dataprofiler.sqlmodel.schema.Schema;
import de.fhtw.dataprofiler.sqlmodel.tables.BaseTable;
import de.fhtw.dataprofiler.sqlmodel.tables.Column;
import de.fhtw.dataprofiler.sqlmodel.tables.PersistentTable;
import de.fhtw.dataprofiler.sqlmodel.tables.Table;

/**
 * @generated
 */
public class SqlmodelDiagramUpdater {

	/**
	 * @generated
	 */
	public static List getSemanticChildren(View view) {
		switch (SqlmodelVisualIDRegistry.getVisualID(view)) {
		case PersistentTableEditPart.VISUAL_ID:
			return getPersistentTable_1001SemanticChildren(view);
		case PersistentTableColumnsCompartmentEditPart.VISUAL_ID:
			return getPersistentTableColumnsCompartment_5001SemanticChildren(view);
		case PrimaryKeyPrimaryKeyColumnsCompartmentEditPart.VISUAL_ID:
			return getPrimaryKeyPrimaryKeyColumnsCompartment_5002SemanticChildren(view);
		case SchemaEditPart.VISUAL_ID:
			return getSchema_79SemanticChildren(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getPersistentTable_1001SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		PersistentTable modelElement = (PersistentTable) view.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getConstraints().iterator(); it.hasNext();) {
			TableConstraint childElement = (TableConstraint) it.next();
			int visualID = SqlmodelVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == PrimaryKeyEditPart.VISUAL_ID) {
				result.add(new SqlmodelNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getPersistentTableColumnsCompartment_5001SemanticChildren(View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		PersistentTable modelElement = (PersistentTable) containerView.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getColumns().iterator(); it.hasNext();) {
			Column childElement = (Column) it.next();
			int visualID = SqlmodelVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == ColumnEditPart.VISUAL_ID) {
				result.add(new SqlmodelNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getPrimaryKeyPrimaryKeyColumnsCompartment_5002SemanticChildren(View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		PrimaryKey modelElement = (PrimaryKey) containerView.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getMembers().iterator(); it.hasNext();) {
			Column childElement = (Column) it.next();
			int visualID = SqlmodelVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == Column2EditPart.VISUAL_ID) {
				result.add(new SqlmodelNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getSchema_79SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		Schema modelElement = (Schema) view.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getTables().iterator(); it.hasNext();) {
			Table childElement = (Table) it.next();
			int visualID = SqlmodelVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == PersistentTableEditPart.VISUAL_ID) {
				result.add(new SqlmodelNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getContainedLinks(View view) {
		switch (SqlmodelVisualIDRegistry.getVisualID(view)) {
		case SchemaEditPart.VISUAL_ID:
			return getSchema_79ContainedLinks(view);
		case PersistentTableEditPart.VISUAL_ID:
			return getPersistentTable_1001ContainedLinks(view);
		case ColumnEditPart.VISUAL_ID:
			return getColumn_2001ContainedLinks(view);
		case PrimaryKeyEditPart.VISUAL_ID:
			return getPrimaryKey_2002ContainedLinks(view);
		case Column2EditPart.VISUAL_ID:
			return getColumn_2003ContainedLinks(view);
		case ForeignKeyEditPart.VISUAL_ID:
			return getForeignKey_3001ContainedLinks(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getIncomingLinks(View view) {
		switch (SqlmodelVisualIDRegistry.getVisualID(view)) {
		case PersistentTableEditPart.VISUAL_ID:
			return getPersistentTable_1001IncomingLinks(view);
		case ColumnEditPart.VISUAL_ID:
			return getColumn_2001IncomingLinks(view);
		case PrimaryKeyEditPart.VISUAL_ID:
			return getPrimaryKey_2002IncomingLinks(view);
		case Column2EditPart.VISUAL_ID:
			return getColumn_2003IncomingLinks(view);
		case ForeignKeyEditPart.VISUAL_ID:
			return getForeignKey_3001IncomingLinks(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getOutgoingLinks(View view) {
		switch (SqlmodelVisualIDRegistry.getVisualID(view)) {
		case PersistentTableEditPart.VISUAL_ID:
			return getPersistentTable_1001OutgoingLinks(view);
		case ColumnEditPart.VISUAL_ID:
			return getColumn_2001OutgoingLinks(view);
		case PrimaryKeyEditPart.VISUAL_ID:
			return getPrimaryKey_2002OutgoingLinks(view);
		case Column2EditPart.VISUAL_ID:
			return getColumn_2003OutgoingLinks(view);
		case ForeignKeyEditPart.VISUAL_ID:
			return getForeignKey_3001OutgoingLinks(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getSchema_79ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getPersistentTable_1001ContainedLinks(View view) {
		PersistentTable modelElement = (PersistentTable) view.getElement();
		List result = new LinkedList();
		result.addAll(getContainedTypeModelFacetLinks_ForeignKey_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getColumn_2001ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getPrimaryKey_2002ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getColumn_2003ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getForeignKey_3001ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getPersistentTable_1001IncomingLinks(View view) {
		PersistentTable modelElement = (PersistentTable) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource().getResourceSet().getResources());
		List result = new LinkedList();
		result.addAll(getIncomingTypeModelFacetLinks_ForeignKey_3001(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getColumn_2001IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getPrimaryKey_2002IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getColumn_2003IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getForeignKey_3001IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getPersistentTable_1001OutgoingLinks(View view) {
		PersistentTable modelElement = (PersistentTable) view.getElement();
		List result = new LinkedList();
		result.addAll(getOutgoingTypeModelFacetLinks_ForeignKey_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getColumn_2001OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getPrimaryKey_2002OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getColumn_2003OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getForeignKey_3001OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	private static Collection getContainedTypeModelFacetLinks_ForeignKey_3001(BaseTable container) {
		Collection result = new LinkedList();
		for (Iterator links = container.getConstraints().iterator(); links.hasNext();) {
			Object linkObject = links.next();
			if (false == linkObject instanceof ForeignKey) {
				continue;
			}
			ForeignKey link = (ForeignKey) linkObject;
			if (ForeignKeyEditPart.VISUAL_ID != SqlmodelVisualIDRegistry.getLinkWithClassVisualID(link)) {
				continue;
			}
			BaseTable dst = link.getReferencedTable();
			BaseTable src = link.getBaseTable();
			result.add(new SqlmodelLinkDescriptor(src, dst, link, SqlmodelElementTypes.ForeignKey_3001,
					ForeignKeyEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getIncomingTypeModelFacetLinks_ForeignKey_3001(BaseTable target, Map crossReferences) {
		Collection result = new LinkedList();
		Collection settings = (Collection) crossReferences.get(target);
		for (Iterator it = settings.iterator(); it.hasNext();) {
			EStructuralFeature.Setting setting = (EStructuralFeature.Setting) it.next();
			if (setting.getEStructuralFeature() != ConstraintsPackage.eINSTANCE.getForeignKey_ReferencedTable()
					|| false == setting.getEObject() instanceof ForeignKey) {
				continue;
			}
			ForeignKey link = (ForeignKey) setting.getEObject();
			if (ForeignKeyEditPart.VISUAL_ID != SqlmodelVisualIDRegistry.getLinkWithClassVisualID(link)) {
				continue;
			}
			BaseTable src = link.getBaseTable();
			result.add(new SqlmodelLinkDescriptor(src, target, link, SqlmodelElementTypes.ForeignKey_3001,
					ForeignKeyEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getOutgoingTypeModelFacetLinks_ForeignKey_3001(BaseTable source) {
		BaseTable container = null;
		// Find container element for the link.
		// Climb up by containment hierarchy starting from the source
		// and return the first element that is instance of the container class.
		for (EObject element = source; element != null && container == null; element = element.eContainer()) {
			if (element instanceof BaseTable) {
				container = (BaseTable) element;
			}
		}
		if (container == null) {
			return Collections.EMPTY_LIST;
		}
		Collection result = new LinkedList();
		for (Iterator links = container.getConstraints().iterator(); links.hasNext();) {
			Object linkObject = links.next();
			if (false == linkObject instanceof ForeignKey) {
				continue;
			}
			ForeignKey link = (ForeignKey) linkObject;
			if (ForeignKeyEditPart.VISUAL_ID != SqlmodelVisualIDRegistry.getLinkWithClassVisualID(link)) {
				continue;
			}
			BaseTable dst = link.getReferencedTable();
			BaseTable src = link.getBaseTable();
			if (src != source) {
				continue;
			}
			result.add(new SqlmodelLinkDescriptor(src, dst, link, SqlmodelElementTypes.ForeignKey_3001,
					ForeignKeyEditPart.VISUAL_ID));
		}
		return result;
	}

}
