package de.fhtw.dataprofiler.sqlmodel.diagram.part;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;

import de.fhtw.dataprofiler.sqlmodel.constraints.ConstraintsPackage;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.Column2EditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.ColumnEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.ForeignKeyEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.ForeignKeyNameEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.PersistentTableColumnsCompartmentEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.PersistentTableEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.PersistentTableNameEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.PrimaryKeyEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.PrimaryKeyPrimaryKeyColumnsCompartmentEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.SchemaEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.WrapLabelEditPart;
import de.fhtw.dataprofiler.sqlmodel.schema.Schema;
import de.fhtw.dataprofiler.sqlmodel.schema.SchemaPackage;
import de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented
 * by a domain model object.
 * 
 * @generated
 */
public class SqlmodelVisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = SqlmodelDiagramEditorPlugin.getInstance().getBundle().getSymbolicName()
			+ "/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (SchemaEditPart.MODEL_ID.equals(view.getType())) {
				return SchemaEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return de.fhtw.dataprofiler.sqlmodel.diagram.part.SqlmodelVisualIDRegistry.getVisualID(view.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(Platform.getDebugOption(DEBUG_KEY))) {
				SqlmodelDiagramEditorPlugin.getInstance().logError(
						"Unable to parse view type as a visualID number: " + type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return String.valueOf(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (SchemaPackage.eINSTANCE.getSchema().isSuperTypeOf(domainElement.eClass())
				&& isDiagram((Schema) domainElement)) {
			return SchemaEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		String containerModelID = de.fhtw.dataprofiler.sqlmodel.diagram.part.SqlmodelVisualIDRegistry
				.getModelID(containerView);
		if (!SchemaEditPart.MODEL_ID.equals(containerModelID)) {
			return -1;
		}
		int containerVisualID;
		if (SchemaEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = de.fhtw.dataprofiler.sqlmodel.diagram.part.SqlmodelVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = SchemaEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		switch (containerVisualID) {
		case PersistentTableEditPart.VISUAL_ID:
			if (ConstraintsPackage.eINSTANCE.getPrimaryKey().isSuperTypeOf(domainElement.eClass())) {
				return PrimaryKeyEditPart.VISUAL_ID;
			}
			break;
		case PersistentTableColumnsCompartmentEditPart.VISUAL_ID:
			if (TablesPackage.eINSTANCE.getColumn().isSuperTypeOf(domainElement.eClass())) {
				return ColumnEditPart.VISUAL_ID;
			}
			break;
		case PrimaryKeyPrimaryKeyColumnsCompartmentEditPart.VISUAL_ID:
			if (TablesPackage.eINSTANCE.getColumn().isSuperTypeOf(domainElement.eClass())) {
				return Column2EditPart.VISUAL_ID;
			}
			break;
		case SchemaEditPart.VISUAL_ID:
			if (TablesPackage.eINSTANCE.getPersistentTable().isSuperTypeOf(domainElement.eClass())) {
				return PersistentTableEditPart.VISUAL_ID;
			}
			break;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static boolean canCreateNode(View containerView, int nodeVisualID) {
		String containerModelID = de.fhtw.dataprofiler.sqlmodel.diagram.part.SqlmodelVisualIDRegistry
				.getModelID(containerView);
		if (!SchemaEditPart.MODEL_ID.equals(containerModelID)) {
			return false;
		}
		int containerVisualID;
		if (SchemaEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = de.fhtw.dataprofiler.sqlmodel.diagram.part.SqlmodelVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = SchemaEditPart.VISUAL_ID;
			} else {
				return false;
			}
		}
		switch (containerVisualID) {
		case PersistentTableEditPart.VISUAL_ID:
			if (PersistentTableNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (PersistentTableColumnsCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (PrimaryKeyEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case PrimaryKeyEditPart.VISUAL_ID:
			if (WrapLabelEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (PrimaryKeyPrimaryKeyColumnsCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case PersistentTableColumnsCompartmentEditPart.VISUAL_ID:
			if (ColumnEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case PrimaryKeyPrimaryKeyColumnsCompartmentEditPart.VISUAL_ID:
			if (Column2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SchemaEditPart.VISUAL_ID:
			if (PersistentTableEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ForeignKeyEditPart.VISUAL_ID:
			if (ForeignKeyNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (ConstraintsPackage.eINSTANCE.getForeignKey().isSuperTypeOf(domainElement.eClass())) {
			return ForeignKeyEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 * 
	 * @generated
	 */
	private static boolean isDiagram(Schema element) {
		return true;
	}

}
