package de.fhtw.dataprofiler.sqlmodel.diagram.providers;

import java.util.HashSet;
import java.util.IdentityHashMap;
import java.util.Map;
import java.util.Set;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.swt.graphics.Image;

import de.fhtw.dataprofiler.sqlmodel.constraints.ConstraintsPackage;
import de.fhtw.dataprofiler.sqlmodel.diagram.part.SqlmodelDiagramEditorPlugin;
import de.fhtw.dataprofiler.sqlmodel.schema.SchemaPackage;
import de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage;

/**
 * @generated
 */
public class SqlmodelElementTypes extends ElementInitializers {

	/**
	 * @generated
	 */
	private SqlmodelElementTypes() {
	}

	/**
	 * @generated
	 */
	private static Map elements;

	/**
	 * @generated
	 */
	private static ImageRegistry imageRegistry;

	/**
	 * @generated
	 */
	private static Set KNOWN_ELEMENT_TYPES;

	/**
	 * @generated
	 */
	public static final IElementType Schema_79 = getElementType("de.fhtw.dataprofiler.sqlmodel.diagram.Schema_79"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType PersistentTable_1001 = getElementType("de.fhtw.dataprofiler.sqlmodel.diagram.PersistentTable_1001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Column_2001 = getElementType("de.fhtw.dataprofiler.sqlmodel.diagram.Column_2001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType PrimaryKey_2002 = getElementType("de.fhtw.dataprofiler.sqlmodel.diagram.PrimaryKey_2002"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Column_2003 = getElementType("de.fhtw.dataprofiler.sqlmodel.diagram.Column_2003"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType ForeignKey_3001 = getElementType("de.fhtw.dataprofiler.sqlmodel.diagram.ForeignKey_3001"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	private static ImageRegistry getImageRegistry() {
		if (imageRegistry == null) {
			imageRegistry = new ImageRegistry();
		}
		return imageRegistry;
	}

	/**
	 * @generated
	 */
	private static String getImageRegistryKey(ENamedElement element) {
		return element.getName();
	}

	/**
	 * @generated
	 */
	private static ImageDescriptor getProvidedImageDescriptor(ENamedElement element) {
		if (element instanceof EStructuralFeature) {
			EStructuralFeature feature = ((EStructuralFeature) element);
			EClass eContainingClass = feature.getEContainingClass();
			EClassifier eType = feature.getEType();
			if (eContainingClass != null && !eContainingClass.isAbstract()) {
				element = eContainingClass;
			} else if (eType instanceof EClass && !((EClass) eType).isAbstract()) {
				element = eType;
			}
		}
		if (element instanceof EClass) {
			EClass eClass = (EClass) element;
			if (!eClass.isAbstract()) {
				return SqlmodelDiagramEditorPlugin.getInstance().getItemImageDescriptor(
						eClass.getEPackage().getEFactoryInstance().create(eClass));
			}
		}
		// TODO : support structural features
		return null;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(ENamedElement element) {
		String key = getImageRegistryKey(element);
		ImageDescriptor imageDescriptor = getImageRegistry().getDescriptor(key);
		if (imageDescriptor == null) {
			imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
		}
		return imageDescriptor;
	}

	/**
	 * @generated
	 */
	public static Image getImage(ENamedElement element) {
		String key = getImageRegistryKey(element);
		Image image = getImageRegistry().get(key);
		if (image == null) {
			ImageDescriptor imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
			image = getImageRegistry().get(key);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImageDescriptor(element);
	}

	/**
	 * @generated
	 */
	public static Image getImage(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImage(element);
	}

	/**
	 * Returns 'type' of the ecore object associated with the hint.
	 * 
	 * @generated
	 */
	public static ENamedElement getElement(IAdaptable hint) {
		Object type = hint.getAdapter(IElementType.class);
		if (elements == null) {
			elements = new IdentityHashMap();

			elements.put(Schema_79, SchemaPackage.eINSTANCE.getSchema());

			elements.put(PersistentTable_1001, TablesPackage.eINSTANCE.getPersistentTable());

			elements.put(Column_2001, TablesPackage.eINSTANCE.getColumn());

			elements.put(PrimaryKey_2002, ConstraintsPackage.eINSTANCE.getPrimaryKey());

			elements.put(Column_2003, TablesPackage.eINSTANCE.getColumn());

			elements.put(ForeignKey_3001, ConstraintsPackage.eINSTANCE.getForeignKey());
		}
		return (ENamedElement) elements.get(type);
	}

	/**
	 * @generated
	 */
	private static IElementType getElementType(String id) {
		return ElementTypeRegistry.getInstance().getType(id);
	}

	/**
	 * @generated
	 */
	public static boolean isKnownElementType(IElementType elementType) {
		if (KNOWN_ELEMENT_TYPES == null) {
			KNOWN_ELEMENT_TYPES = new HashSet();
			KNOWN_ELEMENT_TYPES.add(Schema_79);
			KNOWN_ELEMENT_TYPES.add(PersistentTable_1001);
			KNOWN_ELEMENT_TYPES.add(Column_2001);
			KNOWN_ELEMENT_TYPES.add(PrimaryKey_2002);
			KNOWN_ELEMENT_TYPES.add(Column_2003);
			KNOWN_ELEMENT_TYPES.add(ForeignKey_3001);
		}
		return KNOWN_ELEMENT_TYPES.contains(elementType);
	}

}
