package de.fhtw.dataprofiler.sqlmodel.diagram.providers;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.gmf.runtime.common.core.service.AbstractProvider;
import org.eclipse.gmf.runtime.common.core.service.IOperation;
import org.eclipse.gmf.runtime.common.ui.services.parser.GetParserOperation;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParserProvider;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.ui.services.parser.ParserHintAdapter;
import org.eclipse.gmf.runtime.notation.View;

import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.Column2EditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.ColumnEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.ForeignKeyNameEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.PersistentTableNameEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.parsers.MessageFormatParser;
import de.fhtw.dataprofiler.sqlmodel.diagram.part.SqlmodelVisualIDRegistry;
import de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage;

/**
 * @generated
 */
public class SqlmodelParserProvider extends AbstractProvider implements IParserProvider {

	/**
	 * @generated
	 */
	private IParser persistentTableName_4002Parser;

	/**
	 * @generated
	 */
	private IParser getPersistentTableName_4002Parser() {
		if (persistentTableName_4002Parser == null) {
			persistentTableName_4002Parser = createPersistentTableName_4002Parser();
		}
		return persistentTableName_4002Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createPersistentTableName_4002Parser() {
		EAttribute[] features = new EAttribute[] { EcorePackage.eINSTANCE.getENamedElement_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser column_2001Parser;

	/**
	 * @generated
	 */
	private IParser getColumn_2001Parser() {
		if (column_2001Parser == null) {
			column_2001Parser = createColumn_2001Parser();
		}
		return column_2001Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createColumn_2001Parser() {
		EAttribute[] features = new EAttribute[] { EcorePackage.eINSTANCE.getENamedElement_Name(),
				TablesPackage.eINSTANCE.getColumn_Type(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		parser.setViewPattern("{0} : {1}");
		parser.setEditorPattern("{0} : {1}");
		parser.setEditPattern("{0} : {1}");
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser column_2003Parser;

	/**
	 * @generated
	 */
	private IParser getColumn_2003Parser() {
		if (column_2003Parser == null) {
			column_2003Parser = createColumn_2003Parser();
		}
		return column_2003Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createColumn_2003Parser() {
		EAttribute[] features = new EAttribute[] { EcorePackage.eINSTANCE.getENamedElement_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser foreignKeyName_4003Parser;

	/**
	 * @generated
	 */
	private IParser getForeignKeyName_4003Parser() {
		if (foreignKeyName_4003Parser == null) {
			foreignKeyName_4003Parser = createForeignKeyName_4003Parser();
		}
		return foreignKeyName_4003Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createForeignKeyName_4003Parser() {
		EAttribute[] features = new EAttribute[] { EcorePackage.eINSTANCE.getENamedElement_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	protected IParser getParser(int visualID) {
		switch (visualID) {
		case PersistentTableNameEditPart.VISUAL_ID:
			return getPersistentTableName_4002Parser();
		case ColumnEditPart.VISUAL_ID:
			return getColumn_2001Parser();
		case Column2EditPart.VISUAL_ID:
			return getColumn_2003Parser();
		case ForeignKeyNameEditPart.VISUAL_ID:
			return getForeignKeyName_4003Parser();
		}
		return null;
	}

	/**
	 * @generated
	 */
	public IParser getParser(IAdaptable hint) {
		String vid = (String) hint.getAdapter(String.class);
		if (vid != null) {
			return getParser(SqlmodelVisualIDRegistry.getVisualID(vid));
		}
		View view = (View) hint.getAdapter(View.class);
		if (view != null) {
			return getParser(SqlmodelVisualIDRegistry.getVisualID(view));
		}
		return null;
	}

	/**
	 * @generated
	 */
	public boolean provides(IOperation operation) {
		if (operation instanceof GetParserOperation) {
			IAdaptable hint = ((GetParserOperation) operation).getHint();
			if (SqlmodelElementTypes.getElement(hint) == null) {
				return false;
			}
			return getParser(hint) != null;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static class HintAdapter extends ParserHintAdapter {

		/**
		 * @generated
		 */
		private final IElementType elementType;

		/**
		 * @generated
		 */
		public HintAdapter(IElementType type, EObject object, String parserHint) {
			super(object, parserHint);
			assert type != null;
			elementType = type;
		}

		/**
		 * @generated
		 */
		public Object getAdapter(Class adapter) {
			if (IElementType.class.equals(adapter)) {
				return elementType;
			}
			return super.getAdapter(adapter);
		}
	}

}
