package de.fhtw.dataprofiler.sqlmodel.diagram.providers;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.diagram.core.providers.AbstractViewProvider;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.type.core.IHintedType;
import org.eclipse.gmf.runtime.notation.View;

import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.Column2EditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.ColumnEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.ForeignKeyEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.ForeignKeyNameEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.PersistentTableColumnsCompartmentEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.PersistentTableEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.PersistentTableNameEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.PrimaryKeyEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.PrimaryKeyPrimaryKeyColumnsCompartmentEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.SchemaEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.edit.parts.WrapLabelEditPart;
import de.fhtw.dataprofiler.sqlmodel.diagram.part.SqlmodelVisualIDRegistry;
import de.fhtw.dataprofiler.sqlmodel.diagram.view.factories.Column2ViewFactory;
import de.fhtw.dataprofiler.sqlmodel.diagram.view.factories.ColumnViewFactory;
import de.fhtw.dataprofiler.sqlmodel.diagram.view.factories.ForeignKeyNameViewFactory;
import de.fhtw.dataprofiler.sqlmodel.diagram.view.factories.ForeignKeyViewFactory;
import de.fhtw.dataprofiler.sqlmodel.diagram.view.factories.PersistentTableColumnsCompartmentViewFactory;
import de.fhtw.dataprofiler.sqlmodel.diagram.view.factories.PersistentTableNameViewFactory;
import de.fhtw.dataprofiler.sqlmodel.diagram.view.factories.PersistentTableViewFactory;
import de.fhtw.dataprofiler.sqlmodel.diagram.view.factories.PrimaryKeyPrimaryKeyColumnsCompartmentViewFactory;
import de.fhtw.dataprofiler.sqlmodel.diagram.view.factories.PrimaryKeyViewFactory;
import de.fhtw.dataprofiler.sqlmodel.diagram.view.factories.SchemaViewFactory;
import de.fhtw.dataprofiler.sqlmodel.diagram.view.factories.WrapLabelViewFactory;

/**
 * @generated
 */
public class SqlmodelViewProvider extends AbstractViewProvider {

	/**
	 * @generated
	 */
	protected Class getDiagramViewClass(IAdaptable semanticAdapter, String diagramKind) {
		EObject semanticElement = getSemanticElement(semanticAdapter);
		if (SchemaEditPart.MODEL_ID.equals(diagramKind)
				&& SqlmodelVisualIDRegistry.getDiagramVisualID(semanticElement) != -1) {
			return SchemaViewFactory.class;
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Class getNodeViewClass(IAdaptable semanticAdapter, View containerView, String semanticHint) {
		if (containerView == null) {
			return null;
		}
		IElementType elementType = getSemanticElementType(semanticAdapter);
		EObject domainElement = getSemanticElement(semanticAdapter);
		int visualID;
		if (semanticHint == null) {
			// Semantic hint is not specified. Can be a result of call from CanonicalEditPolicy.
			// In this situation there should be NO elementType, visualID will be determined
			// by VisualIDRegistry.getNodeVisualID() for domainElement.
			if (elementType != null || domainElement == null) {
				return null;
			}
			visualID = SqlmodelVisualIDRegistry.getNodeVisualID(containerView, domainElement);
		} else {
			visualID = SqlmodelVisualIDRegistry.getVisualID(semanticHint);
			if (elementType != null) {
				// Semantic hint is specified together with element type.
				// Both parameters should describe exactly the same diagram element.
				// In addition we check that visualID returned by VisualIDRegistry.getNodeVisualID() for
				// domainElement (if specified) is the same as in element type.
				if (!SqlmodelElementTypes.isKnownElementType(elementType) || (!(elementType instanceof IHintedType))) {
					return null; // foreign element type
				}
				String elementTypeHint = ((IHintedType) elementType).getSemanticHint();
				if (!semanticHint.equals(elementTypeHint)) {
					return null; // if semantic hint is specified it should be the same as in element type
				}
				if (domainElement != null
						&& visualID != SqlmodelVisualIDRegistry.getNodeVisualID(containerView, domainElement)) {
					return null; // visual id for node EClass should match visual id from element type
				}
			} else {
				// Element type is not specified. Domain element should be present (except pure design elements).
				// This method is called with EObjectAdapter as parameter from:
				//   - ViewService.createNode(View container, EObject eObject, String type, PreferencesHint preferencesHint) 
				//   - generated ViewFactory.decorateView() for parent element
				if (!SchemaEditPart.MODEL_ID.equals(SqlmodelVisualIDRegistry.getModelID(containerView))) {
					return null; // foreign diagram
				}
				switch (visualID) {
				case PersistentTableEditPart.VISUAL_ID:
				case ColumnEditPart.VISUAL_ID:
				case PrimaryKeyEditPart.VISUAL_ID:
				case Column2EditPart.VISUAL_ID:
					if (domainElement == null
							|| visualID != SqlmodelVisualIDRegistry.getNodeVisualID(containerView, domainElement)) {
						return null; // visual id in semantic hint should match visual id for domain element
					}
					break;
				case PersistentTableNameEditPart.VISUAL_ID:
				case PersistentTableColumnsCompartmentEditPart.VISUAL_ID:
					if (PersistentTableEditPart.VISUAL_ID != SqlmodelVisualIDRegistry.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case WrapLabelEditPart.VISUAL_ID:
				case PrimaryKeyPrimaryKeyColumnsCompartmentEditPart.VISUAL_ID:
					if (PrimaryKeyEditPart.VISUAL_ID != SqlmodelVisualIDRegistry.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case ForeignKeyNameEditPart.VISUAL_ID:
					if (ForeignKeyEditPart.VISUAL_ID != SqlmodelVisualIDRegistry.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				default:
					return null;
				}
			}
		}
		return getNodeViewClass(containerView, visualID);
	}

	/**
	 * @generated
	 */
	protected Class getNodeViewClass(View containerView, int visualID) {
		if (containerView == null || !SqlmodelVisualIDRegistry.canCreateNode(containerView, visualID)) {
			return null;
		}
		switch (visualID) {
		case PersistentTableEditPart.VISUAL_ID:
			return PersistentTableViewFactory.class;
		case PersistentTableNameEditPart.VISUAL_ID:
			return PersistentTableNameViewFactory.class;
		case ColumnEditPart.VISUAL_ID:
			return ColumnViewFactory.class;
		case PrimaryKeyEditPart.VISUAL_ID:
			return PrimaryKeyViewFactory.class;
		case WrapLabelEditPart.VISUAL_ID:
			return WrapLabelViewFactory.class;
		case Column2EditPart.VISUAL_ID:
			return Column2ViewFactory.class;
		case PersistentTableColumnsCompartmentEditPart.VISUAL_ID:
			return PersistentTableColumnsCompartmentViewFactory.class;
		case PrimaryKeyPrimaryKeyColumnsCompartmentEditPart.VISUAL_ID:
			return PrimaryKeyPrimaryKeyColumnsCompartmentViewFactory.class;
		case ForeignKeyNameEditPart.VISUAL_ID:
			return ForeignKeyNameViewFactory.class;
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Class getEdgeViewClass(IAdaptable semanticAdapter, View containerView, String semanticHint) {
		IElementType elementType = getSemanticElementType(semanticAdapter);
		if (!SqlmodelElementTypes.isKnownElementType(elementType) || (!(elementType instanceof IHintedType))) {
			return null; // foreign element type
		}
		String elementTypeHint = ((IHintedType) elementType).getSemanticHint();
		if (elementTypeHint == null) {
			return null; // our hint is visual id and must be specified
		}
		if (semanticHint != null && !semanticHint.equals(elementTypeHint)) {
			return null; // if semantic hint is specified it should be the same as in element type
		}
		int visualID = SqlmodelVisualIDRegistry.getVisualID(elementTypeHint);
		EObject domainElement = getSemanticElement(semanticAdapter);
		if (domainElement != null && visualID != SqlmodelVisualIDRegistry.getLinkWithClassVisualID(domainElement)) {
			return null; // visual id for link EClass should match visual id from element type
		}
		return getEdgeViewClass(visualID);
	}

	/**
	 * @generated
	 */
	protected Class getEdgeViewClass(int visualID) {
		switch (visualID) {
		case ForeignKeyEditPart.VISUAL_ID:
			return ForeignKeyViewFactory.class;
		}
		return null;
	}

	/**
	 * @generated
	 */
	private IElementType getSemanticElementType(IAdaptable semanticAdapter) {
		if (semanticAdapter == null) {
			return null;
		}
		return (IElementType) semanticAdapter.getAdapter(IElementType.class);
	}
}
