/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package de.fhtw.dataprofiler.sqlmodel.routines;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Data Access</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * <!-- begin-model-doc -->
 * 
 * <!-- end-model-doc -->
 * @see de.fhtw.dataprofiler.sqlmodel.routines.RoutinesPackage#getDataAccess()
 * @model
 * @generated
 */
public enum DataAccess implements Enumerator {
	/**
	 * The '<em><b>NO SQL</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #NO_SQL_VALUE
	 * @generated
	 * @ordered
	 */
	NO_SQL(0, "NO_SQL", "NO_SQL"),

	/**
	 * The '<em><b>CONTAINS SQL</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #CONTAINS_SQL_VALUE
	 * @generated
	 * @ordered
	 */
	CONTAINS_SQL(1, "CONTAINS_SQL", "CONTAINS_SQL"),

	/**
	 * The '<em><b>READS SQL DATA</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #READS_SQL_DATA_VALUE
	 * @generated
	 * @ordered
	 */
	READS_SQL_DATA(2, "READS_SQL_DATA", "READS_SQL_DATA"),

	/**
	 * The '<em><b>MODIFIES SQL DATA</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MODIFIES_SQL_DATA_VALUE
	 * @generated
	 * @ordered
	 */
	MODIFIES_SQL_DATA(3, "MODIFIES_SQL_DATA", "MODIFIES_SQL_DATA");

	/**
	 * The '<em><b>NO SQL</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>NO SQL</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #NO_SQL
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int NO_SQL_VALUE = 0;

	/**
	 * The '<em><b>CONTAINS SQL</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>CONTAINS SQL</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #CONTAINS_SQL
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int CONTAINS_SQL_VALUE = 1;

	/**
	 * The '<em><b>READS SQL DATA</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>READS SQL DATA</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #READS_SQL_DATA
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int READS_SQL_DATA_VALUE = 2;

	/**
	 * The '<em><b>MODIFIES SQL DATA</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>MODIFIES SQL DATA</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #MODIFIES_SQL_DATA
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int MODIFIES_SQL_DATA_VALUE = 3;

	/**
	 * An array of all the '<em><b>Data Access</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final DataAccess[] VALUES_ARRAY =
		new DataAccess[] {
			NO_SQL,
			CONTAINS_SQL,
			READS_SQL_DATA,
			MODIFIES_SQL_DATA,
		};

	/**
	 * A public read-only list of all the '<em><b>Data Access</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<DataAccess> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Data Access</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static DataAccess get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			DataAccess result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Data Access</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static DataAccess getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			DataAccess result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Data Access</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static DataAccess get(int value) {
		switch (value) {
			case NO_SQL_VALUE: return NO_SQL;
			case CONTAINS_SQL_VALUE: return CONTAINS_SQL;
			case READS_SQL_DATA_VALUE: return READS_SQL_DATA;
			case MODIFIES_SQL_DATA_VALUE: return MODIFIES_SQL_DATA;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private DataAccess(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //DataAccess
