/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package de.fhtw.dataprofiler.sqlmodel.routines;

import de.fhtw.dataprofiler.sqlmodel.datatypes.CharacterStringDataType;

import de.fhtw.dataprofiler.sqlmodel.schema.TypedElement;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Parameter</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.routines.Parameter#getMode <em>Mode</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.routines.Parameter#isLocator <em>Locator</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.routines.Parameter#getRoutine <em>Routine</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.routines.Parameter#getStringTypeOption <em>String Type Option</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.fhtw.dataprofiler.sqlmodel.routines.RoutinesPackage#getParameter()
 * @model
 * @generated
 */
public interface Parameter extends TypedElement {
	/**
	 * Returns the value of the '<em><b>Mode</b></em>' attribute.
	 * The literals are from the enumeration {@link de.fhtw.dataprofiler.sqlmodel.routines.ParameterMode}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Mode</em>' attribute.
	 * @see de.fhtw.dataprofiler.sqlmodel.routines.ParameterMode
	 * @see #setMode(ParameterMode)
	 * @see de.fhtw.dataprofiler.sqlmodel.routines.RoutinesPackage#getParameter_Mode()
	 * @model
	 * @generated
	 */
	ParameterMode getMode();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.routines.Parameter#getMode <em>Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Mode</em>' attribute.
	 * @see de.fhtw.dataprofiler.sqlmodel.routines.ParameterMode
	 * @see #getMode()
	 * @generated
	 */
	void setMode(ParameterMode value);

	/**
	 * Returns the value of the '<em><b>Locator</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Locator</em>' attribute.
	 * @see #setLocator(boolean)
	 * @see de.fhtw.dataprofiler.sqlmodel.routines.RoutinesPackage#getParameter_Locator()
	 * @model
	 * @generated
	 */
	boolean isLocator();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.routines.Parameter#isLocator <em>Locator</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Locator</em>' attribute.
	 * @see #isLocator()
	 * @generated
	 */
	void setLocator(boolean value);

	/**
	 * Returns the value of the '<em><b>Routine</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.routines.Routine#getParameters <em>Parameters</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Routine</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Routine</em>' container reference.
	 * @see #setRoutine(Routine)
	 * @see de.fhtw.dataprofiler.sqlmodel.routines.RoutinesPackage#getParameter_Routine()
	 * @see de.fhtw.dataprofiler.sqlmodel.routines.Routine#getParameters
	 * @model opposite="parameters" required="true"
	 * @generated
	 */
	Routine getRoutine();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.routines.Parameter#getRoutine <em>Routine</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Routine</em>' container reference.
	 * @see #getRoutine()
	 * @generated
	 */
	void setRoutine(Routine value);

	/**
	 * Returns the value of the '<em><b>String Type Option</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>String Type Option</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>String Type Option</em>' containment reference.
	 * @see #setStringTypeOption(CharacterStringDataType)
	 * @see de.fhtw.dataprofiler.sqlmodel.routines.RoutinesPackage#getParameter_StringTypeOption()
	 * @model containment="true"
	 * @generated
	 */
	CharacterStringDataType getStringTypeOption();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.routines.Parameter#getStringTypeOption <em>String Type Option</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>String Type Option</em>' containment reference.
	 * @see #getStringTypeOption()
	 * @generated
	 */
	void setStringTypeOption(CharacterStringDataType value);

} // Parameter
