/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package de.fhtw.dataprofiler.sqlmodel.schema;

import de.fhtw.dataprofiler.sqlmodel.accesscontrol.Privilege;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.ENamedElement;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>SQL Object</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.schema.SQLObject#getDependencies <em>Dependencies</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.schema.SQLObject#getDescription <em>Description</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.schema.SQLObject#getLabel <em>Label</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.schema.SQLObject#getComments <em>Comments</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.schema.SQLObject#getPrivileges <em>Privileges</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.fhtw.dataprofiler.sqlmodel.schema.SchemaPackage#getSQLObject()
 * @model abstract="true"
 * @generated
 */
public interface SQLObject extends ENamedElement {
	/**
	 * Returns the value of the '<em><b>Dependencies</b></em>' containment reference list.
	 * The list contents are of type {@link de.fhtw.dataprofiler.sqlmodel.schema.Dependency}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Dependencies</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Dependencies</em>' containment reference list.
	 * @see de.fhtw.dataprofiler.sqlmodel.schema.SchemaPackage#getSQLObject_Dependencies()
	 * @model containment="true"
	 * @generated
	 */
	EList<Dependency> getDependencies();

	/**
	 * Returns the value of the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Description</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Description</em>' attribute.
	 * @see #setDescription(String)
	 * @see de.fhtw.dataprofiler.sqlmodel.schema.SchemaPackage#getSQLObject_Description()
	 * @model
	 * @generated
	 */
	String getDescription();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.schema.SQLObject#getDescription <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Description</em>' attribute.
	 * @see #getDescription()
	 * @generated
	 */
	void setDescription(String value);

	/**
	 * Returns the value of the '<em><b>Label</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Label</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Label</em>' attribute.
	 * @see #setLabel(String)
	 * @see de.fhtw.dataprofiler.sqlmodel.schema.SchemaPackage#getSQLObject_Label()
	 * @model
	 * @generated
	 */
	String getLabel();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.schema.SQLObject#getLabel <em>Label</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Label</em>' attribute.
	 * @see #getLabel()
	 * @generated
	 */
	void setLabel(String value);

	/**
	 * Returns the value of the '<em><b>Comments</b></em>' reference list.
	 * The list contents are of type {@link de.fhtw.dataprofiler.sqlmodel.schema.Comment}.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.schema.Comment#getSQLObject <em>SQL Object</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Comments</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Comments</em>' reference list.
	 * @see de.fhtw.dataprofiler.sqlmodel.schema.SchemaPackage#getSQLObject_Comments()
	 * @see de.fhtw.dataprofiler.sqlmodel.schema.Comment#getSQLObject
	 * @model opposite="SQLObject"
	 * @generated
	 */
	EList<Comment> getComments();

	/**
	 * Returns the value of the '<em><b>Privileges</b></em>' reference list.
	 * The list contents are of type {@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.Privilege}.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.Privilege#getObject <em>Object</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Privileges</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Privileges</em>' reference list.
	 * @see de.fhtw.dataprofiler.sqlmodel.schema.SchemaPackage#getSQLObject_Privileges()
	 * @see de.fhtw.dataprofiler.sqlmodel.accesscontrol.Privilege#getObject
	 * @model opposite="object"
	 * @generated
	 */
	EList<Privilege> getPrivileges();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	EAnnotation addEAnnotation(String source);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void addEAnnotationDetail(EAnnotation eAnnotation, String key, String value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	String getEAnnotationDetail(EAnnotation eAnnotation, String key);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void setAnnotationDetail(EAnnotation eAnnotation, String key, String value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void removeEAnnotationDetail(EAnnotation eAnnotation, String key);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	EAnnotation getEAnnotation(String source);

} // SQLObject
