/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package de.fhtw.dataprofiler.sqlmodel.schema;

import de.fhtw.dataprofiler.sqlmodel.accesscontrol.AuthorizationIdentifier;

import de.fhtw.dataprofiler.sqlmodel.constraints.Assertion;
import de.fhtw.dataprofiler.sqlmodel.constraints.Index;

import de.fhtw.dataprofiler.sqlmodel.datatypes.CharacterSet;
import de.fhtw.dataprofiler.sqlmodel.datatypes.UserDefinedType;

import de.fhtw.dataprofiler.sqlmodel.routines.Routine;

import de.fhtw.dataprofiler.sqlmodel.tables.Table;
import de.fhtw.dataprofiler.sqlmodel.tables.Trigger;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Schema</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.schema.Schema#getTriggers <em>Triggers</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.schema.Schema#getIndices <em>Indices</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.schema.Schema#getTables <em>Tables</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.schema.Schema#getSequences <em>Sequences</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.schema.Schema#getDatabase <em>Database</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.schema.Schema#getCatalog <em>Catalog</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.schema.Schema#getAssertions <em>Assertions</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.schema.Schema#getUserDefinedTypes <em>User Defined Types</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.schema.Schema#getCharSets <em>Char Sets</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.schema.Schema#getRoutines <em>Routines</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.schema.Schema#getOwner <em>Owner</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.fhtw.dataprofiler.sqlmodel.schema.SchemaPackage#getSchema()
 * @model
 * @generated
 */
public interface Schema extends SQLObject {
	/**
	 * Returns the value of the '<em><b>Triggers</b></em>' reference list.
	 * The list contents are of type {@link de.fhtw.dataprofiler.sqlmodel.tables.Trigger}.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.tables.Trigger#getSchema <em>Schema</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Triggers</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Triggers</em>' reference list.
	 * @see de.fhtw.dataprofiler.sqlmodel.schema.SchemaPackage#getSchema_Triggers()
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.Trigger#getSchema
	 * @model opposite="schema"
	 * @generated
	 */
	EList<Trigger> getTriggers();

	/**
	 * Returns the value of the '<em><b>Indices</b></em>' reference list.
	 * The list contents are of type {@link de.fhtw.dataprofiler.sqlmodel.constraints.Index}.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.constraints.Index#getSchema <em>Schema</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Indices</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Indices</em>' reference list.
	 * @see de.fhtw.dataprofiler.sqlmodel.schema.SchemaPackage#getSchema_Indices()
	 * @see de.fhtw.dataprofiler.sqlmodel.constraints.Index#getSchema
	 * @model opposite="Schema"
	 * @generated
	 */
	EList<Index> getIndices();

	/**
	 * Returns the value of the '<em><b>Tables</b></em>' containment reference list.
	 * The list contents are of type {@link de.fhtw.dataprofiler.sqlmodel.tables.Table}.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.tables.Table#getSchema <em>Schema</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Tables</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Tables</em>' containment reference list.
	 * @see de.fhtw.dataprofiler.sqlmodel.schema.SchemaPackage#getSchema_Tables()
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.Table#getSchema
	 * @model opposite="schema" containment="true"
	 * @generated
	 */
	EList<Table> getTables();

	/**
	 * Returns the value of the '<em><b>Sequences</b></em>' reference list.
	 * The list contents are of type {@link de.fhtw.dataprofiler.sqlmodel.schema.Sequence}.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.schema.Sequence#getSchema <em>Schema</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Sequences</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Sequences</em>' reference list.
	 * @see de.fhtw.dataprofiler.sqlmodel.schema.SchemaPackage#getSchema_Sequences()
	 * @see de.fhtw.dataprofiler.sqlmodel.schema.Sequence#getSchema
	 * @model opposite="schema"
	 * @generated
	 */
	EList<Sequence> getSequences();

	/**
	 * Returns the value of the '<em><b>Database</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.schema.Database#getSchemas <em>Schemas</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Database</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Database</em>' reference.
	 * @see #setDatabase(Database)
	 * @see de.fhtw.dataprofiler.sqlmodel.schema.SchemaPackage#getSchema_Database()
	 * @see de.fhtw.dataprofiler.sqlmodel.schema.Database#getSchemas
	 * @model opposite="schemas" required="true"
	 * @generated
	 */
	Database getDatabase();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.schema.Schema#getDatabase <em>Database</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Database</em>' reference.
	 * @see #getDatabase()
	 * @generated
	 */
	void setDatabase(Database value);

	/**
	 * Returns the value of the '<em><b>Catalog</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.schema.Catalog#getSchemas <em>Schemas</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Catalog</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Catalog</em>' reference.
	 * @see #setCatalog(Catalog)
	 * @see de.fhtw.dataprofiler.sqlmodel.schema.SchemaPackage#getSchema_Catalog()
	 * @see de.fhtw.dataprofiler.sqlmodel.schema.Catalog#getSchemas
	 * @model opposite="schemas" required="true"
	 * @generated
	 */
	Catalog getCatalog();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.schema.Schema#getCatalog <em>Catalog</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Catalog</em>' reference.
	 * @see #getCatalog()
	 * @generated
	 */
	void setCatalog(Catalog value);

	/**
	 * Returns the value of the '<em><b>Assertions</b></em>' reference list.
	 * The list contents are of type {@link de.fhtw.dataprofiler.sqlmodel.constraints.Assertion}.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.constraints.Assertion#getSchema <em>Schema</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Assertions</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Assertions</em>' reference list.
	 * @see de.fhtw.dataprofiler.sqlmodel.schema.SchemaPackage#getSchema_Assertions()
	 * @see de.fhtw.dataprofiler.sqlmodel.constraints.Assertion#getSchema
	 * @model opposite="schema"
	 * @generated
	 */
	EList<Assertion> getAssertions();

	/**
	 * Returns the value of the '<em><b>User Defined Types</b></em>' reference list.
	 * The list contents are of type {@link de.fhtw.dataprofiler.sqlmodel.datatypes.UserDefinedType}.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.datatypes.UserDefinedType#getSchema <em>Schema</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>User Defined Types</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>User Defined Types</em>' reference list.
	 * @see de.fhtw.dataprofiler.sqlmodel.schema.SchemaPackage#getSchema_UserDefinedTypes()
	 * @see de.fhtw.dataprofiler.sqlmodel.datatypes.UserDefinedType#getSchema
	 * @model opposite="schema"
	 * @generated
	 */
	EList<UserDefinedType> getUserDefinedTypes();

	/**
	 * Returns the value of the '<em><b>Char Sets</b></em>' reference list.
	 * The list contents are of type {@link de.fhtw.dataprofiler.sqlmodel.datatypes.CharacterSet}.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.datatypes.CharacterSet#getSchema <em>Schema</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Char Sets</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Char Sets</em>' reference list.
	 * @see de.fhtw.dataprofiler.sqlmodel.schema.SchemaPackage#getSchema_CharSets()
	 * @see de.fhtw.dataprofiler.sqlmodel.datatypes.CharacterSet#getSchema
	 * @model opposite="schema"
	 * @generated
	 */
	EList<CharacterSet> getCharSets();

	/**
	 * Returns the value of the '<em><b>Routines</b></em>' reference list.
	 * The list contents are of type {@link de.fhtw.dataprofiler.sqlmodel.routines.Routine}.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.routines.Routine#getSchema <em>Schema</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Routines</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Routines</em>' reference list.
	 * @see de.fhtw.dataprofiler.sqlmodel.schema.SchemaPackage#getSchema_Routines()
	 * @see de.fhtw.dataprofiler.sqlmodel.routines.Routine#getSchema
	 * @model opposite="schema"
	 * @generated
	 */
	EList<Routine> getRoutines();

	/**
	 * Returns the value of the '<em><b>Owner</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.accesscontrol.AuthorizationIdentifier#getOwnedSchema <em>Owned Schema</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Owner</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Owner</em>' reference.
	 * @see #setOwner(AuthorizationIdentifier)
	 * @see de.fhtw.dataprofiler.sqlmodel.schema.SchemaPackage#getSchema_Owner()
	 * @see de.fhtw.dataprofiler.sqlmodel.accesscontrol.AuthorizationIdentifier#getOwnedSchema
	 * @model opposite="ownedSchema" required="true"
	 * @generated
	 */
	AuthorizationIdentifier getOwner();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.schema.Schema#getOwner <em>Owner</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Owner</em>' reference.
	 * @see #getOwner()
	 * @generated
	 */
	void setOwner(AuthorizationIdentifier value);

} // Schema
