/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package de.fhtw.dataprofiler.sqlmodel.schema.impl;

import de.fhtw.dataprofiler.sqlmodel.accesscontrol.AccesscontrolPackage;
import de.fhtw.dataprofiler.sqlmodel.accesscontrol.AuthorizationIdentifier;

import de.fhtw.dataprofiler.sqlmodel.constraints.Assertion;
import de.fhtw.dataprofiler.sqlmodel.constraints.ConstraintsPackage;
import de.fhtw.dataprofiler.sqlmodel.constraints.Index;

import de.fhtw.dataprofiler.sqlmodel.datatypes.CharacterSet;
import de.fhtw.dataprofiler.sqlmodel.datatypes.DatatypesPackage;
import de.fhtw.dataprofiler.sqlmodel.datatypes.UserDefinedType;

import de.fhtw.dataprofiler.sqlmodel.routines.Routine;
import de.fhtw.dataprofiler.sqlmodel.routines.RoutinesPackage;

import de.fhtw.dataprofiler.sqlmodel.schema.Catalog;
import de.fhtw.dataprofiler.sqlmodel.schema.Database;
import de.fhtw.dataprofiler.sqlmodel.schema.Schema;
import de.fhtw.dataprofiler.sqlmodel.schema.SchemaPackage;
import de.fhtw.dataprofiler.sqlmodel.schema.Sequence;

import de.fhtw.dataprofiler.sqlmodel.tables.Table;
import de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage;
import de.fhtw.dataprofiler.sqlmodel.tables.Trigger;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Schema</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.schema.impl.SchemaImpl#getTriggers <em>Triggers</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.schema.impl.SchemaImpl#getIndices <em>Indices</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.schema.impl.SchemaImpl#getTables <em>Tables</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.schema.impl.SchemaImpl#getSequences <em>Sequences</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.schema.impl.SchemaImpl#getDatabase <em>Database</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.schema.impl.SchemaImpl#getCatalog <em>Catalog</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.schema.impl.SchemaImpl#getAssertions <em>Assertions</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.schema.impl.SchemaImpl#getUserDefinedTypes <em>User Defined Types</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.schema.impl.SchemaImpl#getCharSets <em>Char Sets</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.schema.impl.SchemaImpl#getRoutines <em>Routines</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.schema.impl.SchemaImpl#getOwner <em>Owner</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class SchemaImpl extends SQLObjectImpl implements Schema {
	/**
	 * The cached value of the '{@link #getTriggers() <em>Triggers</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTriggers()
	 * @generated
	 * @ordered
	 */
	protected EList<Trigger> triggers;

	/**
	 * The cached value of the '{@link #getIndices() <em>Indices</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIndices()
	 * @generated
	 * @ordered
	 */
	protected EList<Index> indices;

	/**
	 * The cached value of the '{@link #getTables() <em>Tables</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTables()
	 * @generated
	 * @ordered
	 */
	protected EList<Table> tables;

	/**
	 * The cached value of the '{@link #getSequences() <em>Sequences</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSequences()
	 * @generated
	 * @ordered
	 */
	protected EList<Sequence> sequences;

	/**
	 * The cached value of the '{@link #getDatabase() <em>Database</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDatabase()
	 * @generated
	 * @ordered
	 */
	protected Database database;

	/**
	 * The cached value of the '{@link #getCatalog() <em>Catalog</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCatalog()
	 * @generated
	 * @ordered
	 */
	protected Catalog catalog;

	/**
	 * The cached value of the '{@link #getAssertions() <em>Assertions</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAssertions()
	 * @generated
	 * @ordered
	 */
	protected EList<Assertion> assertions;

	/**
	 * The cached value of the '{@link #getUserDefinedTypes() <em>User Defined Types</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUserDefinedTypes()
	 * @generated
	 * @ordered
	 */
	protected EList<UserDefinedType> userDefinedTypes;

	/**
	 * The cached value of the '{@link #getCharSets() <em>Char Sets</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCharSets()
	 * @generated
	 * @ordered
	 */
	protected EList<CharacterSet> charSets;

	/**
	 * The cached value of the '{@link #getRoutines() <em>Routines</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRoutines()
	 * @generated
	 * @ordered
	 */
	protected EList<Routine> routines;

	/**
	 * The cached value of the '{@link #getOwner() <em>Owner</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOwner()
	 * @generated
	 * @ordered
	 */
	protected AuthorizationIdentifier owner;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SchemaImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return SchemaPackage.Literals.SCHEMA;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Trigger> getTriggers() {
		if (triggers == null) {
			triggers = new EObjectWithInverseResolvingEList<Trigger>(Trigger.class, this, SchemaPackage.SCHEMA__TRIGGERS, TablesPackage.TRIGGER__SCHEMA);
		}
		return triggers;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Index> getIndices() {
		if (indices == null) {
			indices = new EObjectWithInverseResolvingEList<Index>(Index.class, this, SchemaPackage.SCHEMA__INDICES, ConstraintsPackage.INDEX__SCHEMA);
		}
		return indices;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Table> getTables() {
		if (tables == null) {
			tables = new EObjectContainmentWithInverseEList<Table>(Table.class, this, SchemaPackage.SCHEMA__TABLES, TablesPackage.TABLE__SCHEMA);
		}
		return tables;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Sequence> getSequences() {
		if (sequences == null) {
			sequences = new EObjectWithInverseResolvingEList<Sequence>(Sequence.class, this, SchemaPackage.SCHEMA__SEQUENCES, SchemaPackage.SEQUENCE__SCHEMA);
		}
		return sequences;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Database getDatabase() {
		if (database != null && database.eIsProxy()) {
			InternalEObject oldDatabase = (InternalEObject)database;
			database = (Database)eResolveProxy(oldDatabase);
			if (database != oldDatabase) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, SchemaPackage.SCHEMA__DATABASE, oldDatabase, database));
			}
		}
		return database;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Database basicGetDatabase() {
		return database;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetDatabase(Database newDatabase, NotificationChain msgs) {
		Database oldDatabase = database;
		database = newDatabase;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SchemaPackage.SCHEMA__DATABASE, oldDatabase, newDatabase);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDatabase(Database newDatabase) {
		if (newDatabase != database) {
			NotificationChain msgs = null;
			if (database != null)
				msgs = ((InternalEObject)database).eInverseRemove(this, SchemaPackage.DATABASE__SCHEMAS, Database.class, msgs);
			if (newDatabase != null)
				msgs = ((InternalEObject)newDatabase).eInverseAdd(this, SchemaPackage.DATABASE__SCHEMAS, Database.class, msgs);
			msgs = basicSetDatabase(newDatabase, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SchemaPackage.SCHEMA__DATABASE, newDatabase, newDatabase));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Catalog getCatalog() {
		if (catalog != null && catalog.eIsProxy()) {
			InternalEObject oldCatalog = (InternalEObject)catalog;
			catalog = (Catalog)eResolveProxy(oldCatalog);
			if (catalog != oldCatalog) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, SchemaPackage.SCHEMA__CATALOG, oldCatalog, catalog));
			}
		}
		return catalog;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Catalog basicGetCatalog() {
		return catalog;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetCatalog(Catalog newCatalog, NotificationChain msgs) {
		Catalog oldCatalog = catalog;
		catalog = newCatalog;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SchemaPackage.SCHEMA__CATALOG, oldCatalog, newCatalog);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCatalog(Catalog newCatalog) {
		if (newCatalog != catalog) {
			NotificationChain msgs = null;
			if (catalog != null)
				msgs = ((InternalEObject)catalog).eInverseRemove(this, SchemaPackage.CATALOG__SCHEMAS, Catalog.class, msgs);
			if (newCatalog != null)
				msgs = ((InternalEObject)newCatalog).eInverseAdd(this, SchemaPackage.CATALOG__SCHEMAS, Catalog.class, msgs);
			msgs = basicSetCatalog(newCatalog, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SchemaPackage.SCHEMA__CATALOG, newCatalog, newCatalog));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Assertion> getAssertions() {
		if (assertions == null) {
			assertions = new EObjectWithInverseResolvingEList<Assertion>(Assertion.class, this, SchemaPackage.SCHEMA__ASSERTIONS, ConstraintsPackage.ASSERTION__SCHEMA);
		}
		return assertions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<UserDefinedType> getUserDefinedTypes() {
		if (userDefinedTypes == null) {
			userDefinedTypes = new EObjectWithInverseResolvingEList<UserDefinedType>(UserDefinedType.class, this, SchemaPackage.SCHEMA__USER_DEFINED_TYPES, DatatypesPackage.USER_DEFINED_TYPE__SCHEMA);
		}
		return userDefinedTypes;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<CharacterSet> getCharSets() {
		if (charSets == null) {
			charSets = new EObjectWithInverseResolvingEList<CharacterSet>(CharacterSet.class, this, SchemaPackage.SCHEMA__CHAR_SETS, DatatypesPackage.CHARACTER_SET__SCHEMA);
		}
		return charSets;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Routine> getRoutines() {
		if (routines == null) {
			routines = new EObjectWithInverseResolvingEList<Routine>(Routine.class, this, SchemaPackage.SCHEMA__ROUTINES, RoutinesPackage.ROUTINE__SCHEMA);
		}
		return routines;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AuthorizationIdentifier getOwner() {
		if (owner != null && owner.eIsProxy()) {
			InternalEObject oldOwner = (InternalEObject)owner;
			owner = (AuthorizationIdentifier)eResolveProxy(oldOwner);
			if (owner != oldOwner) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, SchemaPackage.SCHEMA__OWNER, oldOwner, owner));
			}
		}
		return owner;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AuthorizationIdentifier basicGetOwner() {
		return owner;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetOwner(AuthorizationIdentifier newOwner, NotificationChain msgs) {
		AuthorizationIdentifier oldOwner = owner;
		owner = newOwner;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SchemaPackage.SCHEMA__OWNER, oldOwner, newOwner);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setOwner(AuthorizationIdentifier newOwner) {
		if (newOwner != owner) {
			NotificationChain msgs = null;
			if (owner != null)
				msgs = ((InternalEObject)owner).eInverseRemove(this, AccesscontrolPackage.AUTHORIZATION_IDENTIFIER__OWNED_SCHEMA, AuthorizationIdentifier.class, msgs);
			if (newOwner != null)
				msgs = ((InternalEObject)newOwner).eInverseAdd(this, AccesscontrolPackage.AUTHORIZATION_IDENTIFIER__OWNED_SCHEMA, AuthorizationIdentifier.class, msgs);
			msgs = basicSetOwner(newOwner, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SchemaPackage.SCHEMA__OWNER, newOwner, newOwner));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SchemaPackage.SCHEMA__TRIGGERS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getTriggers()).basicAdd(otherEnd, msgs);
			case SchemaPackage.SCHEMA__INDICES:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getIndices()).basicAdd(otherEnd, msgs);
			case SchemaPackage.SCHEMA__TABLES:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getTables()).basicAdd(otherEnd, msgs);
			case SchemaPackage.SCHEMA__SEQUENCES:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getSequences()).basicAdd(otherEnd, msgs);
			case SchemaPackage.SCHEMA__DATABASE:
				if (database != null)
					msgs = ((InternalEObject)database).eInverseRemove(this, SchemaPackage.DATABASE__SCHEMAS, Database.class, msgs);
				return basicSetDatabase((Database)otherEnd, msgs);
			case SchemaPackage.SCHEMA__CATALOG:
				if (catalog != null)
					msgs = ((InternalEObject)catalog).eInverseRemove(this, SchemaPackage.CATALOG__SCHEMAS, Catalog.class, msgs);
				return basicSetCatalog((Catalog)otherEnd, msgs);
			case SchemaPackage.SCHEMA__ASSERTIONS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getAssertions()).basicAdd(otherEnd, msgs);
			case SchemaPackage.SCHEMA__USER_DEFINED_TYPES:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getUserDefinedTypes()).basicAdd(otherEnd, msgs);
			case SchemaPackage.SCHEMA__CHAR_SETS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getCharSets()).basicAdd(otherEnd, msgs);
			case SchemaPackage.SCHEMA__ROUTINES:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getRoutines()).basicAdd(otherEnd, msgs);
			case SchemaPackage.SCHEMA__OWNER:
				if (owner != null)
					msgs = ((InternalEObject)owner).eInverseRemove(this, AccesscontrolPackage.AUTHORIZATION_IDENTIFIER__OWNED_SCHEMA, AuthorizationIdentifier.class, msgs);
				return basicSetOwner((AuthorizationIdentifier)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SchemaPackage.SCHEMA__TRIGGERS:
				return ((InternalEList<?>)getTriggers()).basicRemove(otherEnd, msgs);
			case SchemaPackage.SCHEMA__INDICES:
				return ((InternalEList<?>)getIndices()).basicRemove(otherEnd, msgs);
			case SchemaPackage.SCHEMA__TABLES:
				return ((InternalEList<?>)getTables()).basicRemove(otherEnd, msgs);
			case SchemaPackage.SCHEMA__SEQUENCES:
				return ((InternalEList<?>)getSequences()).basicRemove(otherEnd, msgs);
			case SchemaPackage.SCHEMA__DATABASE:
				return basicSetDatabase(null, msgs);
			case SchemaPackage.SCHEMA__CATALOG:
				return basicSetCatalog(null, msgs);
			case SchemaPackage.SCHEMA__ASSERTIONS:
				return ((InternalEList<?>)getAssertions()).basicRemove(otherEnd, msgs);
			case SchemaPackage.SCHEMA__USER_DEFINED_TYPES:
				return ((InternalEList<?>)getUserDefinedTypes()).basicRemove(otherEnd, msgs);
			case SchemaPackage.SCHEMA__CHAR_SETS:
				return ((InternalEList<?>)getCharSets()).basicRemove(otherEnd, msgs);
			case SchemaPackage.SCHEMA__ROUTINES:
				return ((InternalEList<?>)getRoutines()).basicRemove(otherEnd, msgs);
			case SchemaPackage.SCHEMA__OWNER:
				return basicSetOwner(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case SchemaPackage.SCHEMA__TRIGGERS:
				return getTriggers();
			case SchemaPackage.SCHEMA__INDICES:
				return getIndices();
			case SchemaPackage.SCHEMA__TABLES:
				return getTables();
			case SchemaPackage.SCHEMA__SEQUENCES:
				return getSequences();
			case SchemaPackage.SCHEMA__DATABASE:
				if (resolve) return getDatabase();
				return basicGetDatabase();
			case SchemaPackage.SCHEMA__CATALOG:
				if (resolve) return getCatalog();
				return basicGetCatalog();
			case SchemaPackage.SCHEMA__ASSERTIONS:
				return getAssertions();
			case SchemaPackage.SCHEMA__USER_DEFINED_TYPES:
				return getUserDefinedTypes();
			case SchemaPackage.SCHEMA__CHAR_SETS:
				return getCharSets();
			case SchemaPackage.SCHEMA__ROUTINES:
				return getRoutines();
			case SchemaPackage.SCHEMA__OWNER:
				if (resolve) return getOwner();
				return basicGetOwner();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case SchemaPackage.SCHEMA__TRIGGERS:
				getTriggers().clear();
				getTriggers().addAll((Collection<? extends Trigger>)newValue);
				return;
			case SchemaPackage.SCHEMA__INDICES:
				getIndices().clear();
				getIndices().addAll((Collection<? extends Index>)newValue);
				return;
			case SchemaPackage.SCHEMA__TABLES:
				getTables().clear();
				getTables().addAll((Collection<? extends Table>)newValue);
				return;
			case SchemaPackage.SCHEMA__SEQUENCES:
				getSequences().clear();
				getSequences().addAll((Collection<? extends Sequence>)newValue);
				return;
			case SchemaPackage.SCHEMA__DATABASE:
				setDatabase((Database)newValue);
				return;
			case SchemaPackage.SCHEMA__CATALOG:
				setCatalog((Catalog)newValue);
				return;
			case SchemaPackage.SCHEMA__ASSERTIONS:
				getAssertions().clear();
				getAssertions().addAll((Collection<? extends Assertion>)newValue);
				return;
			case SchemaPackage.SCHEMA__USER_DEFINED_TYPES:
				getUserDefinedTypes().clear();
				getUserDefinedTypes().addAll((Collection<? extends UserDefinedType>)newValue);
				return;
			case SchemaPackage.SCHEMA__CHAR_SETS:
				getCharSets().clear();
				getCharSets().addAll((Collection<? extends CharacterSet>)newValue);
				return;
			case SchemaPackage.SCHEMA__ROUTINES:
				getRoutines().clear();
				getRoutines().addAll((Collection<? extends Routine>)newValue);
				return;
			case SchemaPackage.SCHEMA__OWNER:
				setOwner((AuthorizationIdentifier)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case SchemaPackage.SCHEMA__TRIGGERS:
				getTriggers().clear();
				return;
			case SchemaPackage.SCHEMA__INDICES:
				getIndices().clear();
				return;
			case SchemaPackage.SCHEMA__TABLES:
				getTables().clear();
				return;
			case SchemaPackage.SCHEMA__SEQUENCES:
				getSequences().clear();
				return;
			case SchemaPackage.SCHEMA__DATABASE:
				setDatabase((Database)null);
				return;
			case SchemaPackage.SCHEMA__CATALOG:
				setCatalog((Catalog)null);
				return;
			case SchemaPackage.SCHEMA__ASSERTIONS:
				getAssertions().clear();
				return;
			case SchemaPackage.SCHEMA__USER_DEFINED_TYPES:
				getUserDefinedTypes().clear();
				return;
			case SchemaPackage.SCHEMA__CHAR_SETS:
				getCharSets().clear();
				return;
			case SchemaPackage.SCHEMA__ROUTINES:
				getRoutines().clear();
				return;
			case SchemaPackage.SCHEMA__OWNER:
				setOwner((AuthorizationIdentifier)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case SchemaPackage.SCHEMA__TRIGGERS:
				return triggers != null && !triggers.isEmpty();
			case SchemaPackage.SCHEMA__INDICES:
				return indices != null && !indices.isEmpty();
			case SchemaPackage.SCHEMA__TABLES:
				return tables != null && !tables.isEmpty();
			case SchemaPackage.SCHEMA__SEQUENCES:
				return sequences != null && !sequences.isEmpty();
			case SchemaPackage.SCHEMA__DATABASE:
				return database != null;
			case SchemaPackage.SCHEMA__CATALOG:
				return catalog != null;
			case SchemaPackage.SCHEMA__ASSERTIONS:
				return assertions != null && !assertions.isEmpty();
			case SchemaPackage.SCHEMA__USER_DEFINED_TYPES:
				return userDefinedTypes != null && !userDefinedTypes.isEmpty();
			case SchemaPackage.SCHEMA__CHAR_SETS:
				return charSets != null && !charSets.isEmpty();
			case SchemaPackage.SCHEMA__ROUTINES:
				return routines != null && !routines.isEmpty();
			case SchemaPackage.SCHEMA__OWNER:
				return owner != null;
		}
		return super.eIsSet(featureID);
	}

} //SchemaImpl
