/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package de.fhtw.dataprofiler.sqlmodel.statements;

import de.fhtw.dataprofiler.sqlmodel.schema.SchemaPackage;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see de.fhtw.dataprofiler.sqlmodel.statements.StatementsFactory
 * @model kind="package"
 * @generated
 */
public interface StatementsPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "statements";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http:///org/eclipse/datatools/modelbase/sql/statements.ecore";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "SQLStatements";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	StatementsPackage eINSTANCE = de.fhtw.dataprofiler.sqlmodel.statements.impl.StatementsPackageImpl.init();

	/**
	 * The meta object id for the '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLStatement <em>SQL Statement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLStatement
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.impl.StatementsPackageImpl#getSQLStatement()
	 * @generated
	 */
	int SQL_STATEMENT = 0;

	/**
	 * The number of structural features of the '<em>SQL Statement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SQL_STATEMENT_FEATURE_COUNT = 0;

	/**
	 * The meta object id for the '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLDataStatement <em>SQL Data Statement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLDataStatement
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.impl.StatementsPackageImpl#getSQLDataStatement()
	 * @generated
	 */
	int SQL_DATA_STATEMENT = 1;

	/**
	 * The number of structural features of the '<em>SQL Data Statement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SQL_DATA_STATEMENT_FEATURE_COUNT = SQL_STATEMENT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLSchemaStatement <em>SQL Schema Statement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLSchemaStatement
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.impl.StatementsPackageImpl#getSQLSchemaStatement()
	 * @generated
	 */
	int SQL_SCHEMA_STATEMENT = 2;

	/**
	 * The number of structural features of the '<em>SQL Schema Statement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SQL_SCHEMA_STATEMENT_FEATURE_COUNT = SQL_STATEMENT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLControlStatement <em>SQL Control Statement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLControlStatement
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.impl.StatementsPackageImpl#getSQLControlStatement()
	 * @generated
	 */
	int SQL_CONTROL_STATEMENT = 3;

	/**
	 * The number of structural features of the '<em>SQL Control Statement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SQL_CONTROL_STATEMENT_FEATURE_COUNT = SQL_STATEMENT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLDataChangeStatement <em>SQL Data Change Statement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLDataChangeStatement
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.impl.StatementsPackageImpl#getSQLDataChangeStatement()
	 * @generated
	 */
	int SQL_DATA_CHANGE_STATEMENT = 4;

	/**
	 * The number of structural features of the '<em>SQL Data Change Statement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SQL_DATA_CHANGE_STATEMENT_FEATURE_COUNT = SQL_DATA_STATEMENT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.fhtw.dataprofiler.sqlmodel.statements.impl.SQLStatementDefaultImpl <em>SQL Statement Default</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.impl.SQLStatementDefaultImpl
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.impl.StatementsPackageImpl#getSQLStatementDefault()
	 * @generated
	 */
	int SQL_STATEMENT_DEFAULT = 5;

	/**
	 * The feature id for the '<em><b>EAnnotations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SQL_STATEMENT_DEFAULT__EANNOTATIONS = SchemaPackage.SQL_OBJECT__EANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SQL_STATEMENT_DEFAULT__NAME = SchemaPackage.SQL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Dependencies</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SQL_STATEMENT_DEFAULT__DEPENDENCIES = SchemaPackage.SQL_OBJECT__DEPENDENCIES;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SQL_STATEMENT_DEFAULT__DESCRIPTION = SchemaPackage.SQL_OBJECT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Label</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SQL_STATEMENT_DEFAULT__LABEL = SchemaPackage.SQL_OBJECT__LABEL;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SQL_STATEMENT_DEFAULT__COMMENTS = SchemaPackage.SQL_OBJECT__COMMENTS;

	/**
	 * The feature id for the '<em><b>Privileges</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SQL_STATEMENT_DEFAULT__PRIVILEGES = SchemaPackage.SQL_OBJECT__PRIVILEGES;

	/**
	 * The feature id for the '<em><b>SQL</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SQL_STATEMENT_DEFAULT__SQL = SchemaPackage.SQL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>SQL Statement Default</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SQL_STATEMENT_DEFAULT_FEATURE_COUNT = SchemaPackage.SQL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLConnectionStatement <em>SQL Connection Statement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLConnectionStatement
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.impl.StatementsPackageImpl#getSQLConnectionStatement()
	 * @generated
	 */
	int SQL_CONNECTION_STATEMENT = 6;

	/**
	 * The number of structural features of the '<em>SQL Connection Statement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SQL_CONNECTION_STATEMENT_FEATURE_COUNT = SQL_STATEMENT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLDiagnosticsStatement <em>SQL Diagnostics Statement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLDiagnosticsStatement
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.impl.StatementsPackageImpl#getSQLDiagnosticsStatement()
	 * @generated
	 */
	int SQL_DIAGNOSTICS_STATEMENT = 7;

	/**
	 * The number of structural features of the '<em>SQL Diagnostics Statement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SQL_DIAGNOSTICS_STATEMENT_FEATURE_COUNT = SQL_STATEMENT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLDynamicStatement <em>SQL Dynamic Statement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLDynamicStatement
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.impl.StatementsPackageImpl#getSQLDynamicStatement()
	 * @generated
	 */
	int SQL_DYNAMIC_STATEMENT = 8;

	/**
	 * The number of structural features of the '<em>SQL Dynamic Statement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SQL_DYNAMIC_STATEMENT_FEATURE_COUNT = SQL_STATEMENT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLSessionStatement <em>SQL Session Statement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLSessionStatement
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.impl.StatementsPackageImpl#getSQLSessionStatement()
	 * @generated
	 */
	int SQL_SESSION_STATEMENT = 9;

	/**
	 * The number of structural features of the '<em>SQL Session Statement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SQL_SESSION_STATEMENT_FEATURE_COUNT = SQL_STATEMENT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLTransactionStatement <em>SQL Transaction Statement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLTransactionStatement
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.impl.StatementsPackageImpl#getSQLTransactionStatement()
	 * @generated
	 */
	int SQL_TRANSACTION_STATEMENT = 10;

	/**
	 * The number of structural features of the '<em>SQL Transaction Statement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SQL_TRANSACTION_STATEMENT_FEATURE_COUNT = SQL_STATEMENT_FEATURE_COUNT + 0;


	/**
	 * Returns the meta object for class '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLStatement <em>SQL Statement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>SQL Statement</em>'.
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLStatement
	 * @generated
	 */
	EClass getSQLStatement();

	/**
	 * Returns the meta object for class '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLDataStatement <em>SQL Data Statement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>SQL Data Statement</em>'.
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLDataStatement
	 * @generated
	 */
	EClass getSQLDataStatement();

	/**
	 * Returns the meta object for class '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLSchemaStatement <em>SQL Schema Statement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>SQL Schema Statement</em>'.
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLSchemaStatement
	 * @generated
	 */
	EClass getSQLSchemaStatement();

	/**
	 * Returns the meta object for class '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLControlStatement <em>SQL Control Statement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>SQL Control Statement</em>'.
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLControlStatement
	 * @generated
	 */
	EClass getSQLControlStatement();

	/**
	 * Returns the meta object for class '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLDataChangeStatement <em>SQL Data Change Statement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>SQL Data Change Statement</em>'.
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLDataChangeStatement
	 * @generated
	 */
	EClass getSQLDataChangeStatement();

	/**
	 * Returns the meta object for class '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLStatementDefault <em>SQL Statement Default</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>SQL Statement Default</em>'.
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLStatementDefault
	 * @generated
	 */
	EClass getSQLStatementDefault();

	/**
	 * Returns the meta object for the attribute '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLStatementDefault#getSQL <em>SQL</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>SQL</em>'.
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLStatementDefault#getSQL()
	 * @see #getSQLStatementDefault()
	 * @generated
	 */
	EAttribute getSQLStatementDefault_SQL();

	/**
	 * Returns the meta object for class '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLConnectionStatement <em>SQL Connection Statement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>SQL Connection Statement</em>'.
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLConnectionStatement
	 * @generated
	 */
	EClass getSQLConnectionStatement();

	/**
	 * Returns the meta object for class '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLDiagnosticsStatement <em>SQL Diagnostics Statement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>SQL Diagnostics Statement</em>'.
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLDiagnosticsStatement
	 * @generated
	 */
	EClass getSQLDiagnosticsStatement();

	/**
	 * Returns the meta object for class '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLDynamicStatement <em>SQL Dynamic Statement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>SQL Dynamic Statement</em>'.
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLDynamicStatement
	 * @generated
	 */
	EClass getSQLDynamicStatement();

	/**
	 * Returns the meta object for class '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLSessionStatement <em>SQL Session Statement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>SQL Session Statement</em>'.
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLSessionStatement
	 * @generated
	 */
	EClass getSQLSessionStatement();

	/**
	 * Returns the meta object for class '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLTransactionStatement <em>SQL Transaction Statement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>SQL Transaction Statement</em>'.
	 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLTransactionStatement
	 * @generated
	 */
	EClass getSQLTransactionStatement();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	StatementsFactory getStatementsFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLStatement <em>SQL Statement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLStatement
		 * @see de.fhtw.dataprofiler.sqlmodel.statements.impl.StatementsPackageImpl#getSQLStatement()
		 * @generated
		 */
		EClass SQL_STATEMENT = eINSTANCE.getSQLStatement();

		/**
		 * The meta object literal for the '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLDataStatement <em>SQL Data Statement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLDataStatement
		 * @see de.fhtw.dataprofiler.sqlmodel.statements.impl.StatementsPackageImpl#getSQLDataStatement()
		 * @generated
		 */
		EClass SQL_DATA_STATEMENT = eINSTANCE.getSQLDataStatement();

		/**
		 * The meta object literal for the '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLSchemaStatement <em>SQL Schema Statement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLSchemaStatement
		 * @see de.fhtw.dataprofiler.sqlmodel.statements.impl.StatementsPackageImpl#getSQLSchemaStatement()
		 * @generated
		 */
		EClass SQL_SCHEMA_STATEMENT = eINSTANCE.getSQLSchemaStatement();

		/**
		 * The meta object literal for the '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLControlStatement <em>SQL Control Statement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLControlStatement
		 * @see de.fhtw.dataprofiler.sqlmodel.statements.impl.StatementsPackageImpl#getSQLControlStatement()
		 * @generated
		 */
		EClass SQL_CONTROL_STATEMENT = eINSTANCE.getSQLControlStatement();

		/**
		 * The meta object literal for the '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLDataChangeStatement <em>SQL Data Change Statement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLDataChangeStatement
		 * @see de.fhtw.dataprofiler.sqlmodel.statements.impl.StatementsPackageImpl#getSQLDataChangeStatement()
		 * @generated
		 */
		EClass SQL_DATA_CHANGE_STATEMENT = eINSTANCE.getSQLDataChangeStatement();

		/**
		 * The meta object literal for the '{@link de.fhtw.dataprofiler.sqlmodel.statements.impl.SQLStatementDefaultImpl <em>SQL Statement Default</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.fhtw.dataprofiler.sqlmodel.statements.impl.SQLStatementDefaultImpl
		 * @see de.fhtw.dataprofiler.sqlmodel.statements.impl.StatementsPackageImpl#getSQLStatementDefault()
		 * @generated
		 */
		EClass SQL_STATEMENT_DEFAULT = eINSTANCE.getSQLStatementDefault();

		/**
		 * The meta object literal for the '<em><b>SQL</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SQL_STATEMENT_DEFAULT__SQL = eINSTANCE.getSQLStatementDefault_SQL();

		/**
		 * The meta object literal for the '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLConnectionStatement <em>SQL Connection Statement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLConnectionStatement
		 * @see de.fhtw.dataprofiler.sqlmodel.statements.impl.StatementsPackageImpl#getSQLConnectionStatement()
		 * @generated
		 */
		EClass SQL_CONNECTION_STATEMENT = eINSTANCE.getSQLConnectionStatement();

		/**
		 * The meta object literal for the '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLDiagnosticsStatement <em>SQL Diagnostics Statement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLDiagnosticsStatement
		 * @see de.fhtw.dataprofiler.sqlmodel.statements.impl.StatementsPackageImpl#getSQLDiagnosticsStatement()
		 * @generated
		 */
		EClass SQL_DIAGNOSTICS_STATEMENT = eINSTANCE.getSQLDiagnosticsStatement();

		/**
		 * The meta object literal for the '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLDynamicStatement <em>SQL Dynamic Statement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLDynamicStatement
		 * @see de.fhtw.dataprofiler.sqlmodel.statements.impl.StatementsPackageImpl#getSQLDynamicStatement()
		 * @generated
		 */
		EClass SQL_DYNAMIC_STATEMENT = eINSTANCE.getSQLDynamicStatement();

		/**
		 * The meta object literal for the '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLSessionStatement <em>SQL Session Statement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLSessionStatement
		 * @see de.fhtw.dataprofiler.sqlmodel.statements.impl.StatementsPackageImpl#getSQLSessionStatement()
		 * @generated
		 */
		EClass SQL_SESSION_STATEMENT = eINSTANCE.getSQLSessionStatement();

		/**
		 * The meta object literal for the '{@link de.fhtw.dataprofiler.sqlmodel.statements.SQLTransactionStatement <em>SQL Transaction Statement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.fhtw.dataprofiler.sqlmodel.statements.SQLTransactionStatement
		 * @see de.fhtw.dataprofiler.sqlmodel.statements.impl.StatementsPackageImpl#getSQLTransactionStatement()
		 * @generated
		 */
		EClass SQL_TRANSACTION_STATEMENT = eINSTANCE.getSQLTransactionStatement();

	}

} //StatementsPackage
