/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package de.fhtw.dataprofiler.sqlmodel.statements.util;

import de.fhtw.dataprofiler.sqlmodel.schema.SQLObject;

import de.fhtw.dataprofiler.sqlmodel.statements.*;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EModelElement;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see de.fhtw.dataprofiler.sqlmodel.statements.StatementsPackage
 * @generated
 */
public class StatementsSwitch<T> {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static StatementsPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public StatementsSwitch() {
		if (modelPackage == null) {
			modelPackage = StatementsPackage.eINSTANCE;
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	public T doSwitch(EObject theEObject) {
		return doSwitch(theEObject.eClass(), theEObject);
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected T doSwitch(EClass theEClass, EObject theEObject) {
		if (theEClass.eContainer() == modelPackage) {
			return doSwitch(theEClass.getClassifierID(), theEObject);
		}
		else {
			List<EClass> eSuperTypes = theEClass.getESuperTypes();
			return
				eSuperTypes.isEmpty() ?
					defaultCase(theEObject) :
					doSwitch(eSuperTypes.get(0), theEObject);
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected T doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case StatementsPackage.SQL_STATEMENT: {
				SQLStatement sqlStatement = (SQLStatement)theEObject;
				T result = caseSQLStatement(sqlStatement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case StatementsPackage.SQL_DATA_STATEMENT: {
				SQLDataStatement sqlDataStatement = (SQLDataStatement)theEObject;
				T result = caseSQLDataStatement(sqlDataStatement);
				if (result == null) result = caseSQLStatement(sqlDataStatement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case StatementsPackage.SQL_SCHEMA_STATEMENT: {
				SQLSchemaStatement sqlSchemaStatement = (SQLSchemaStatement)theEObject;
				T result = caseSQLSchemaStatement(sqlSchemaStatement);
				if (result == null) result = caseSQLStatement(sqlSchemaStatement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case StatementsPackage.SQL_CONTROL_STATEMENT: {
				SQLControlStatement sqlControlStatement = (SQLControlStatement)theEObject;
				T result = caseSQLControlStatement(sqlControlStatement);
				if (result == null) result = caseSQLStatement(sqlControlStatement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case StatementsPackage.SQL_DATA_CHANGE_STATEMENT: {
				SQLDataChangeStatement sqlDataChangeStatement = (SQLDataChangeStatement)theEObject;
				T result = caseSQLDataChangeStatement(sqlDataChangeStatement);
				if (result == null) result = caseSQLDataStatement(sqlDataChangeStatement);
				if (result == null) result = caseSQLStatement(sqlDataChangeStatement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case StatementsPackage.SQL_STATEMENT_DEFAULT: {
				SQLStatementDefault sqlStatementDefault = (SQLStatementDefault)theEObject;
				T result = caseSQLStatementDefault(sqlStatementDefault);
				if (result == null) result = caseSQLObject(sqlStatementDefault);
				if (result == null) result = caseSQLStatement(sqlStatementDefault);
				if (result == null) result = caseENamedElement(sqlStatementDefault);
				if (result == null) result = caseEModelElement(sqlStatementDefault);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case StatementsPackage.SQL_CONNECTION_STATEMENT: {
				SQLConnectionStatement sqlConnectionStatement = (SQLConnectionStatement)theEObject;
				T result = caseSQLConnectionStatement(sqlConnectionStatement);
				if (result == null) result = caseSQLStatement(sqlConnectionStatement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case StatementsPackage.SQL_DIAGNOSTICS_STATEMENT: {
				SQLDiagnosticsStatement sqlDiagnosticsStatement = (SQLDiagnosticsStatement)theEObject;
				T result = caseSQLDiagnosticsStatement(sqlDiagnosticsStatement);
				if (result == null) result = caseSQLStatement(sqlDiagnosticsStatement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case StatementsPackage.SQL_DYNAMIC_STATEMENT: {
				SQLDynamicStatement sqlDynamicStatement = (SQLDynamicStatement)theEObject;
				T result = caseSQLDynamicStatement(sqlDynamicStatement);
				if (result == null) result = caseSQLStatement(sqlDynamicStatement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case StatementsPackage.SQL_SESSION_STATEMENT: {
				SQLSessionStatement sqlSessionStatement = (SQLSessionStatement)theEObject;
				T result = caseSQLSessionStatement(sqlSessionStatement);
				if (result == null) result = caseSQLStatement(sqlSessionStatement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case StatementsPackage.SQL_TRANSACTION_STATEMENT: {
				SQLTransactionStatement sqlTransactionStatement = (SQLTransactionStatement)theEObject;
				T result = caseSQLTransactionStatement(sqlTransactionStatement);
				if (result == null) result = caseSQLStatement(sqlTransactionStatement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>SQL Statement</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>SQL Statement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSQLStatement(SQLStatement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>SQL Data Statement</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>SQL Data Statement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSQLDataStatement(SQLDataStatement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>SQL Schema Statement</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>SQL Schema Statement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSQLSchemaStatement(SQLSchemaStatement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>SQL Control Statement</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>SQL Control Statement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSQLControlStatement(SQLControlStatement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>SQL Data Change Statement</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>SQL Data Change Statement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSQLDataChangeStatement(SQLDataChangeStatement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>SQL Statement Default</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>SQL Statement Default</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSQLStatementDefault(SQLStatementDefault object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>SQL Connection Statement</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>SQL Connection Statement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSQLConnectionStatement(SQLConnectionStatement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>SQL Diagnostics Statement</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>SQL Diagnostics Statement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSQLDiagnosticsStatement(SQLDiagnosticsStatement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>SQL Dynamic Statement</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>SQL Dynamic Statement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSQLDynamicStatement(SQLDynamicStatement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>SQL Session Statement</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>SQL Session Statement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSQLSessionStatement(SQLSessionStatement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>SQL Transaction Statement</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>SQL Transaction Statement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSQLTransactionStatement(SQLTransactionStatement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EModel Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EModel Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEModelElement(EModelElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>ENamed Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>ENamed Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseENamedElement(ENamedElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>SQL Object</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>SQL Object</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSQLObject(SQLObject object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	public T defaultCase(EObject object) {
		return null;
	}

} //StatementsSwitch
