/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package de.fhtw.dataprofiler.sqlmodel.tables;

import de.fhtw.dataprofiler.sqlmodel.constraints.ForeignKey;
import de.fhtw.dataprofiler.sqlmodel.constraints.PrimaryKey;
import de.fhtw.dataprofiler.sqlmodel.constraints.TableConstraint;

import java.util.List;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Base Table</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.BaseTable#getConstraints <em>Constraints</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.BaseTable#getReferencingForeignKeys <em>Referencing Foreign Keys</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage#getBaseTable()
 * @model abstract="true"
 * @generated
 */
public interface BaseTable extends Table {
	/**
	 * Returns the value of the '<em><b>Constraints</b></em>' containment reference list.
	 * The list contents are of type {@link de.fhtw.dataprofiler.sqlmodel.constraints.TableConstraint}.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.constraints.TableConstraint#getBaseTable <em>Base Table</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Constraints</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Constraints</em>' containment reference list.
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage#getBaseTable_Constraints()
	 * @see de.fhtw.dataprofiler.sqlmodel.constraints.TableConstraint#getBaseTable
	 * @model opposite="BaseTable" containment="true"
	 * @generated
	 */
	EList<TableConstraint> getConstraints();

	/**
	 * Returns the value of the '<em><b>Referencing Foreign Keys</b></em>' reference list.
	 * The list contents are of type {@link de.fhtw.dataprofiler.sqlmodel.constraints.ForeignKey}.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.constraints.ForeignKey#getReferencedTable <em>Referenced Table</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Referencing Foreign Keys</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Referencing Foreign Keys</em>' reference list.
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage#getBaseTable_ReferencingForeignKeys()
	 * @see de.fhtw.dataprofiler.sqlmodel.constraints.ForeignKey#getReferencedTable
	 * @model opposite="referencedTable"
	 * @generated
	 */
	EList<ForeignKey> getReferencingForeignKeys();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model kind="operation" dataType="de.fhtw.dataprofiler.sqlmodel.schema.List" many="false"
	 * @generated
	 */
	List getUniqueConstraints();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model kind="operation" dataType="de.fhtw.dataprofiler.sqlmodel.schema.List" many="false"
	 * @generated
	 */
	List getForeignKeys();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model kind="operation"
	 * @generated
	 */
	PrimaryKey getPrimaryKey();

} // BaseTable
