/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package de.fhtw.dataprofiler.sqlmodel.tables;

import de.fhtw.dataprofiler.sqlmodel.expressions.ValueExpression;

import de.fhtw.dataprofiler.sqlmodel.schema.IdentitySpecifier;
import de.fhtw.dataprofiler.sqlmodel.schema.ReferentialActionType;
import de.fhtw.dataprofiler.sqlmodel.schema.TypedElement;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Column</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#getTable <em>Table</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#getIdentitySpecifier <em>Identity Specifier</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#getGenerateExpression <em>Generate Expression</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#isImplementationDependent <em>Implementation Dependent</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#isNullable <em>Nullable</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#getDefaultValue <em>Default Value</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#getScopeCheck <em>Scope Check</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#isScopeChecked <em>Scope Checked</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#getType <em>Type</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#getTotalValues <em>Total Values</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#getDistinctValues <em>Distinct Values</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#getNullValues <em>Null Values</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#getMinValue <em>Min Value</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#getMaxValue <em>Max Value</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#getMinLength <em>Min Length</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#getMaxLength <em>Max Length</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage#getColumn()
 * @model
 * @generated
 */
public interface Column extends TypedElement {
	/**
	 * Returns the value of the '<em><b>Table</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.tables.Table#getColumns <em>Columns</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Table</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Table</em>' container reference.
	 * @see #setTable(Table)
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage#getColumn_Table()
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.Table#getColumns
	 * @model opposite="columns" required="true"
	 * @generated
	 */
	Table getTable();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#getTable <em>Table</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Table</em>' container reference.
	 * @see #getTable()
	 * @generated
	 */
	void setTable(Table value);

	/**
	 * Returns the value of the '<em><b>Identity Specifier</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Identity Specifier</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Identity Specifier</em>' containment reference.
	 * @see #setIdentitySpecifier(IdentitySpecifier)
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage#getColumn_IdentitySpecifier()
	 * @model containment="true"
	 * @generated
	 */
	IdentitySpecifier getIdentitySpecifier();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#getIdentitySpecifier <em>Identity Specifier</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Identity Specifier</em>' containment reference.
	 * @see #getIdentitySpecifier()
	 * @generated
	 */
	void setIdentitySpecifier(IdentitySpecifier value);

	/**
	 * Returns the value of the '<em><b>Generate Expression</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Generate Expression</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Generate Expression</em>' containment reference.
	 * @see #setGenerateExpression(ValueExpression)
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage#getColumn_GenerateExpression()
	 * @model containment="true"
	 * @generated
	 */
	ValueExpression getGenerateExpression();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#getGenerateExpression <em>Generate Expression</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Generate Expression</em>' containment reference.
	 * @see #getGenerateExpression()
	 * @generated
	 */
	void setGenerateExpression(ValueExpression value);

	/**
	 * Returns the value of the '<em><b>Implementation Dependent</b></em>' attribute.
	 * The default value is <code>"False"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Implementation Dependent</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Implementation Dependent</em>' attribute.
	 * @see #setImplementationDependent(boolean)
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage#getColumn_ImplementationDependent()
	 * @model default="False"
	 * @generated
	 */
	boolean isImplementationDependent();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#isImplementationDependent <em>Implementation Dependent</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Implementation Dependent</em>' attribute.
	 * @see #isImplementationDependent()
	 * @generated
	 */
	void setImplementationDependent(boolean value);

	/**
	 * Returns the value of the '<em><b>Nullable</b></em>' attribute.
	 * The default value is <code>"True"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Nullable</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Nullable</em>' attribute.
	 * @see #setNullable(boolean)
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage#getColumn_Nullable()
	 * @model default="True"
	 * @generated
	 */
	boolean isNullable();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#isNullable <em>Nullable</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Nullable</em>' attribute.
	 * @see #isNullable()
	 * @generated
	 */
	void setNullable(boolean value);

	/**
	 * Returns the value of the '<em><b>Default Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Default Value</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Default Value</em>' attribute.
	 * @see #setDefaultValue(String)
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage#getColumn_DefaultValue()
	 * @model
	 * @generated
	 */
	String getDefaultValue();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#getDefaultValue <em>Default Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Default Value</em>' attribute.
	 * @see #getDefaultValue()
	 * @generated
	 */
	void setDefaultValue(String value);

	/**
	 * Returns the value of the '<em><b>Scope Check</b></em>' attribute.
	 * The default value is <code>"NO_ACTION"</code>.
	 * The literals are from the enumeration {@link de.fhtw.dataprofiler.sqlmodel.schema.ReferentialActionType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Scope Check</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Scope Check</em>' attribute.
	 * @see de.fhtw.dataprofiler.sqlmodel.schema.ReferentialActionType
	 * @see #setScopeCheck(ReferentialActionType)
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage#getColumn_ScopeCheck()
	 * @model default="NO_ACTION"
	 * @generated
	 */
	ReferentialActionType getScopeCheck();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#getScopeCheck <em>Scope Check</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Scope Check</em>' attribute.
	 * @see de.fhtw.dataprofiler.sqlmodel.schema.ReferentialActionType
	 * @see #getScopeCheck()
	 * @generated
	 */
	void setScopeCheck(ReferentialActionType value);

	/**
	 * Returns the value of the '<em><b>Scope Checked</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Scope Checked</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Scope Checked</em>' attribute.
	 * @see #setScopeChecked(boolean)
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage#getColumn_ScopeChecked()
	 * @model
	 * @generated
	 */
	boolean isScopeChecked();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#isScopeChecked <em>Scope Checked</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Scope Checked</em>' attribute.
	 * @see #isScopeChecked()
	 * @generated
	 */
	void setScopeChecked(boolean value);

	/**
	 * Returns the value of the '<em><b>Type</b></em>' attribute.
	 * The default value is <code>""</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type</em>' attribute.
	 * @see #setType(String)
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage#getColumn_Type()
	 * @model default=""
	 * @generated
	 */
	String getType();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#getType <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' attribute.
	 * @see #getType()
	 * @generated
	 */
	void setType(String value);

	/**
	 * Returns the value of the '<em><b>Total Values</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Total Values</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Total Values</em>' attribute.
	 * @see #setTotalValues(int)
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage#getColumn_TotalValues()
	 * @model
	 * @generated
	 */
	int getTotalValues();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#getTotalValues <em>Total Values</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Total Values</em>' attribute.
	 * @see #getTotalValues()
	 * @generated
	 */
	void setTotalValues(int value);

	/**
	 * Returns the value of the '<em><b>Distinct Values</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Distinct Values</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Distinct Values</em>' attribute.
	 * @see #setDistinctValues(int)
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage#getColumn_DistinctValues()
	 * @model
	 * @generated
	 */
	int getDistinctValues();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#getDistinctValues <em>Distinct Values</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Distinct Values</em>' attribute.
	 * @see #getDistinctValues()
	 * @generated
	 */
	void setDistinctValues(int value);

	/**
	 * Returns the value of the '<em><b>Null Values</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Null Values</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Null Values</em>' attribute.
	 * @see #setNullValues(int)
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage#getColumn_NullValues()
	 * @model
	 * @generated
	 */
	int getNullValues();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#getNullValues <em>Null Values</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Null Values</em>' attribute.
	 * @see #getNullValues()
	 * @generated
	 */
	void setNullValues(int value);

	/**
	 * Returns the value of the '<em><b>Min Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Min Value</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Min Value</em>' attribute.
	 * @see #setMinValue(String)
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage#getColumn_MinValue()
	 * @model
	 * @generated
	 */
	String getMinValue();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#getMinValue <em>Min Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Min Value</em>' attribute.
	 * @see #getMinValue()
	 * @generated
	 */
	void setMinValue(String value);

	/**
	 * Returns the value of the '<em><b>Max Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Max Value</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Max Value</em>' attribute.
	 * @see #setMaxValue(String)
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage#getColumn_MaxValue()
	 * @model
	 * @generated
	 */
	String getMaxValue();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#getMaxValue <em>Max Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Max Value</em>' attribute.
	 * @see #getMaxValue()
	 * @generated
	 */
	void setMaxValue(String value);

	/**
	 * Returns the value of the '<em><b>Min Length</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Min Length</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Min Length</em>' attribute.
	 * @see #setMinLength(int)
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage#getColumn_MinLength()
	 * @model
	 * @generated
	 */
	int getMinLength();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#getMinLength <em>Min Length</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Min Length</em>' attribute.
	 * @see #getMinLength()
	 * @generated
	 */
	void setMinLength(int value);

	/**
	 * Returns the value of the '<em><b>Max Length</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Max Length</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Max Length</em>' attribute.
	 * @see #setMaxLength(int)
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage#getColumn_MaxLength()
	 * @model
	 * @generated
	 */
	int getMaxLength();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#getMaxLength <em>Max Length</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Max Length</em>' attribute.
	 * @see #getMaxLength()
	 * @generated
	 */
	void setMaxLength(int value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model kind="operation"
	 * @generated
	 */
	boolean isPartOfForeignKey();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model kind="operation"
	 * @generated
	 */
	boolean isPartOfUniqueConstraint();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model kind="operation"
	 * @generated
	 */
	boolean isPartOfPrimaryKey();

} // Column
