/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package de.fhtw.dataprofiler.sqlmodel.tables;

import de.fhtw.dataprofiler.sqlmodel.constraints.Index;

import de.fhtw.dataprofiler.sqlmodel.datatypes.StructuredUserDefinedType;

import de.fhtw.dataprofiler.sqlmodel.schema.SQLObject;
import de.fhtw.dataprofiler.sqlmodel.schema.Schema;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Table</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.Table#getColumns <em>Columns</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.Table#getSupertable <em>Supertable</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.Table#getSubtables <em>Subtables</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.Table#getSchema <em>Schema</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.Table#getUdt <em>Udt</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.Table#getTriggers <em>Triggers</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.Table#getIndex <em>Index</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.Table#getSelfRefColumnGeneration <em>Self Ref Column Generation</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.Table#isInsertable <em>Insertable</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.Table#isUpdatable <em>Updatable</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage#getTable()
 * @model abstract="true"
 * @generated
 */
public interface Table extends SQLObject {
	/**
	 * Returns the value of the '<em><b>Columns</b></em>' containment reference list.
	 * The list contents are of type {@link de.fhtw.dataprofiler.sqlmodel.tables.Column}.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.tables.Column#getTable <em>Table</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Columns</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Columns</em>' containment reference list.
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage#getTable_Columns()
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.Column#getTable
	 * @model opposite="table" containment="true" required="true"
	 * @generated
	 */
	EList<Column> getColumns();

	/**
	 * Returns the value of the '<em><b>Supertable</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.tables.Table#getSubtables <em>Subtables</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Supertable</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Supertable</em>' reference.
	 * @see #setSupertable(Table)
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage#getTable_Supertable()
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.Table#getSubtables
	 * @model opposite="subtables"
	 * @generated
	 */
	Table getSupertable();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.tables.Table#getSupertable <em>Supertable</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Supertable</em>' reference.
	 * @see #getSupertable()
	 * @generated
	 */
	void setSupertable(Table value);

	/**
	 * Returns the value of the '<em><b>Subtables</b></em>' reference list.
	 * The list contents are of type {@link de.fhtw.dataprofiler.sqlmodel.tables.Table}.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.tables.Table#getSupertable <em>Supertable</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Subtables</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Subtables</em>' reference list.
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage#getTable_Subtables()
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.Table#getSupertable
	 * @model opposite="supertable"
	 * @generated
	 */
	EList<Table> getSubtables();

	/**
	 * Returns the value of the '<em><b>Schema</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.schema.Schema#getTables <em>Tables</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Schema</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Schema</em>' container reference.
	 * @see #setSchema(Schema)
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage#getTable_Schema()
	 * @see de.fhtw.dataprofiler.sqlmodel.schema.Schema#getTables
	 * @model opposite="tables" required="true" transient="false"
	 * @generated
	 */
	Schema getSchema();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.tables.Table#getSchema <em>Schema</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Schema</em>' container reference.
	 * @see #getSchema()
	 * @generated
	 */
	void setSchema(Schema value);

	/**
	 * Returns the value of the '<em><b>Udt</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Udt</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Udt</em>' reference.
	 * @see #setUdt(StructuredUserDefinedType)
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage#getTable_Udt()
	 * @model
	 * @generated
	 */
	StructuredUserDefinedType getUdt();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.tables.Table#getUdt <em>Udt</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Udt</em>' reference.
	 * @see #getUdt()
	 * @generated
	 */
	void setUdt(StructuredUserDefinedType value);

	/**
	 * Returns the value of the '<em><b>Triggers</b></em>' reference list.
	 * The list contents are of type {@link de.fhtw.dataprofiler.sqlmodel.tables.Trigger}.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.tables.Trigger#getSubjectTable <em>Subject Table</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Triggers</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Triggers</em>' reference list.
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage#getTable_Triggers()
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.Trigger#getSubjectTable
	 * @model opposite="subjectTable"
	 * @generated
	 */
	EList<Trigger> getTriggers();

	/**
	 * Returns the value of the '<em><b>Index</b></em>' reference list.
	 * The list contents are of type {@link de.fhtw.dataprofiler.sqlmodel.constraints.Index}.
	 * It is bidirectional and its opposite is '{@link de.fhtw.dataprofiler.sqlmodel.constraints.Index#getTable <em>Table</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Index</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Index</em>' reference list.
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage#getTable_Index()
	 * @see de.fhtw.dataprofiler.sqlmodel.constraints.Index#getTable
	 * @model opposite="table"
	 * @generated
	 */
	EList<Index> getIndex();

	/**
	 * Returns the value of the '<em><b>Self Ref Column Generation</b></em>' attribute.
	 * The literals are from the enumeration {@link de.fhtw.dataprofiler.sqlmodel.tables.ReferenceType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Self Ref Column Generation</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Self Ref Column Generation</em>' attribute.
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.ReferenceType
	 * @see #setSelfRefColumnGeneration(ReferenceType)
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage#getTable_SelfRefColumnGeneration()
	 * @model
	 * @generated
	 */
	ReferenceType getSelfRefColumnGeneration();

	/**
	 * Sets the value of the '{@link de.fhtw.dataprofiler.sqlmodel.tables.Table#getSelfRefColumnGeneration <em>Self Ref Column Generation</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Self Ref Column Generation</em>' attribute.
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.ReferenceType
	 * @see #getSelfRefColumnGeneration()
	 * @generated
	 */
	void setSelfRefColumnGeneration(ReferenceType value);

	/**
	 * Returns the value of the '<em><b>Insertable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Insertable</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Insertable</em>' attribute.
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage#getTable_Insertable()
	 * @model transient="true" changeable="false" volatile="true" derived="true"
	 * @generated
	 */
	boolean isInsertable();

	/**
	 * Returns the value of the '<em><b>Updatable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Updatable</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Updatable</em>' attribute.
	 * @see de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage#getTable_Updatable()
	 * @model transient="true" changeable="false" volatile="true" derived="true"
	 * @generated
	 */
	boolean isUpdatable();

} // Table
