/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package de.fhtw.dataprofiler.sqlmodel.tables.impl;

import de.fhtw.dataprofiler.sqlmodel.constraints.ConstraintsPackage;
import de.fhtw.dataprofiler.sqlmodel.constraints.Index;

import de.fhtw.dataprofiler.sqlmodel.datatypes.StructuredUserDefinedType;

import de.fhtw.dataprofiler.sqlmodel.schema.Schema;
import de.fhtw.dataprofiler.sqlmodel.schema.SchemaPackage;

import de.fhtw.dataprofiler.sqlmodel.schema.impl.SQLObjectImpl;

import de.fhtw.dataprofiler.sqlmodel.tables.Column;
import de.fhtw.dataprofiler.sqlmodel.tables.ReferenceType;
import de.fhtw.dataprofiler.sqlmodel.tables.Table;
import de.fhtw.dataprofiler.sqlmodel.tables.TablesPackage;
import de.fhtw.dataprofiler.sqlmodel.tables.Trigger;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Table</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.impl.TableImpl#getColumns <em>Columns</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.impl.TableImpl#getSupertable <em>Supertable</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.impl.TableImpl#getSubtables <em>Subtables</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.impl.TableImpl#getSchema <em>Schema</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.impl.TableImpl#getUdt <em>Udt</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.impl.TableImpl#getTriggers <em>Triggers</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.impl.TableImpl#getIndex <em>Index</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.impl.TableImpl#getSelfRefColumnGeneration <em>Self Ref Column Generation</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.impl.TableImpl#isInsertable <em>Insertable</em>}</li>
 *   <li>{@link de.fhtw.dataprofiler.sqlmodel.tables.impl.TableImpl#isUpdatable <em>Updatable</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class TableImpl extends SQLObjectImpl implements Table {
	/**
	 * The cached value of the '{@link #getColumns() <em>Columns</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getColumns()
	 * @generated
	 * @ordered
	 */
	protected EList<Column> columns;

	/**
	 * The cached value of the '{@link #getSupertable() <em>Supertable</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSupertable()
	 * @generated
	 * @ordered
	 */
	protected Table supertable;

	/**
	 * The cached value of the '{@link #getSubtables() <em>Subtables</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSubtables()
	 * @generated
	 * @ordered
	 */
	protected EList<Table> subtables;

	/**
	 * The cached value of the '{@link #getUdt() <em>Udt</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUdt()
	 * @generated
	 * @ordered
	 */
	protected StructuredUserDefinedType udt;

	/**
	 * The cached value of the '{@link #getTriggers() <em>Triggers</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTriggers()
	 * @generated
	 * @ordered
	 */
	protected EList<Trigger> triggers;

	/**
	 * The cached value of the '{@link #getIndex() <em>Index</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIndex()
	 * @generated
	 * @ordered
	 */
	protected EList<Index> index;

	/**
	 * The default value of the '{@link #getSelfRefColumnGeneration() <em>Self Ref Column Generation</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSelfRefColumnGeneration()
	 * @generated
	 * @ordered
	 */
	protected static final ReferenceType SELF_REF_COLUMN_GENERATION_EDEFAULT = ReferenceType.SYSTEM_GENERATED;

	/**
	 * The cached value of the '{@link #getSelfRefColumnGeneration() <em>Self Ref Column Generation</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSelfRefColumnGeneration()
	 * @generated
	 * @ordered
	 */
	protected ReferenceType selfRefColumnGeneration = SELF_REF_COLUMN_GENERATION_EDEFAULT;

	/**
	 * The default value of the '{@link #isInsertable() <em>Insertable</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isInsertable()
	 * @generated
	 * @ordered
	 */
	protected static final boolean INSERTABLE_EDEFAULT = false;

	/**
	 * The default value of the '{@link #isUpdatable() <em>Updatable</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isUpdatable()
	 * @generated
	 * @ordered
	 */
	protected static final boolean UPDATABLE_EDEFAULT = false;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TableImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return TablesPackage.Literals.TABLE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Column> getColumns() {
		if (columns == null) {
			columns = new EObjectContainmentWithInverseEList<Column>(Column.class, this, TablesPackage.TABLE__COLUMNS, TablesPackage.COLUMN__TABLE);
		}
		return columns;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Table getSupertable() {
		if (supertable != null && supertable.eIsProxy()) {
			InternalEObject oldSupertable = (InternalEObject)supertable;
			supertable = (Table)eResolveProxy(oldSupertable);
			if (supertable != oldSupertable) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, TablesPackage.TABLE__SUPERTABLE, oldSupertable, supertable));
			}
		}
		return supertable;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Table basicGetSupertable() {
		return supertable;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetSupertable(Table newSupertable, NotificationChain msgs) {
		Table oldSupertable = supertable;
		supertable = newSupertable;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, TablesPackage.TABLE__SUPERTABLE, oldSupertable, newSupertable);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSupertable(Table newSupertable) {
		if (newSupertable != supertable) {
			NotificationChain msgs = null;
			if (supertable != null)
				msgs = ((InternalEObject)supertable).eInverseRemove(this, TablesPackage.TABLE__SUBTABLES, Table.class, msgs);
			if (newSupertable != null)
				msgs = ((InternalEObject)newSupertable).eInverseAdd(this, TablesPackage.TABLE__SUBTABLES, Table.class, msgs);
			msgs = basicSetSupertable(newSupertable, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TablesPackage.TABLE__SUPERTABLE, newSupertable, newSupertable));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Table> getSubtables() {
		if (subtables == null) {
			subtables = new EObjectWithInverseResolvingEList<Table>(Table.class, this, TablesPackage.TABLE__SUBTABLES, TablesPackage.TABLE__SUPERTABLE);
		}
		return subtables;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Schema getSchema() {
		if (eContainerFeatureID != TablesPackage.TABLE__SCHEMA) return null;
		return (Schema)eContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetSchema(Schema newSchema, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newSchema, TablesPackage.TABLE__SCHEMA, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSchema(Schema newSchema) {
		if (newSchema != eInternalContainer() || (eContainerFeatureID != TablesPackage.TABLE__SCHEMA && newSchema != null)) {
			if (EcoreUtil.isAncestor(this, newSchema))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newSchema != null)
				msgs = ((InternalEObject)newSchema).eInverseAdd(this, SchemaPackage.SCHEMA__TABLES, Schema.class, msgs);
			msgs = basicSetSchema(newSchema, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TablesPackage.TABLE__SCHEMA, newSchema, newSchema));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public StructuredUserDefinedType getUdt() {
		if (udt != null && udt.eIsProxy()) {
			InternalEObject oldUdt = (InternalEObject)udt;
			udt = (StructuredUserDefinedType)eResolveProxy(oldUdt);
			if (udt != oldUdt) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, TablesPackage.TABLE__UDT, oldUdt, udt));
			}
		}
		return udt;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public StructuredUserDefinedType basicGetUdt() {
		return udt;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setUdt(StructuredUserDefinedType newUdt) {
		StructuredUserDefinedType oldUdt = udt;
		udt = newUdt;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TablesPackage.TABLE__UDT, oldUdt, udt));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Trigger> getTriggers() {
		if (triggers == null) {
			triggers = new EObjectWithInverseResolvingEList<Trigger>(Trigger.class, this, TablesPackage.TABLE__TRIGGERS, TablesPackage.TRIGGER__SUBJECT_TABLE);
		}
		return triggers;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Index> getIndex() {
		if (index == null) {
			index = new EObjectWithInverseResolvingEList<Index>(Index.class, this, TablesPackage.TABLE__INDEX, ConstraintsPackage.INDEX__TABLE);
		}
		return index;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ReferenceType getSelfRefColumnGeneration() {
		return selfRefColumnGeneration;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSelfRefColumnGeneration(ReferenceType newSelfRefColumnGeneration) {
		ReferenceType oldSelfRefColumnGeneration = selfRefColumnGeneration;
		selfRefColumnGeneration = newSelfRefColumnGeneration == null ? SELF_REF_COLUMN_GENERATION_EDEFAULT : newSelfRefColumnGeneration;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TablesPackage.TABLE__SELF_REF_COLUMN_GENERATION, oldSelfRefColumnGeneration, selfRefColumnGeneration));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isInsertable() {
		// TODO: implement this method to return the 'Insertable' attribute
		// Ensure that you remove @generated or mark it @generated NOT
		throw new UnsupportedOperationException();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isUpdatable() {
		// TODO: implement this method to return the 'Updatable' attribute
		// Ensure that you remove @generated or mark it @generated NOT
		throw new UnsupportedOperationException();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case TablesPackage.TABLE__COLUMNS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getColumns()).basicAdd(otherEnd, msgs);
			case TablesPackage.TABLE__SUPERTABLE:
				if (supertable != null)
					msgs = ((InternalEObject)supertable).eInverseRemove(this, TablesPackage.TABLE__SUBTABLES, Table.class, msgs);
				return basicSetSupertable((Table)otherEnd, msgs);
			case TablesPackage.TABLE__SUBTABLES:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getSubtables()).basicAdd(otherEnd, msgs);
			case TablesPackage.TABLE__SCHEMA:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetSchema((Schema)otherEnd, msgs);
			case TablesPackage.TABLE__TRIGGERS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getTriggers()).basicAdd(otherEnd, msgs);
			case TablesPackage.TABLE__INDEX:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getIndex()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case TablesPackage.TABLE__COLUMNS:
				return ((InternalEList<?>)getColumns()).basicRemove(otherEnd, msgs);
			case TablesPackage.TABLE__SUPERTABLE:
				return basicSetSupertable(null, msgs);
			case TablesPackage.TABLE__SUBTABLES:
				return ((InternalEList<?>)getSubtables()).basicRemove(otherEnd, msgs);
			case TablesPackage.TABLE__SCHEMA:
				return basicSetSchema(null, msgs);
			case TablesPackage.TABLE__TRIGGERS:
				return ((InternalEList<?>)getTriggers()).basicRemove(otherEnd, msgs);
			case TablesPackage.TABLE__INDEX:
				return ((InternalEList<?>)getIndex()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID) {
			case TablesPackage.TABLE__SCHEMA:
				return eInternalContainer().eInverseRemove(this, SchemaPackage.SCHEMA__TABLES, Schema.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case TablesPackage.TABLE__COLUMNS:
				return getColumns();
			case TablesPackage.TABLE__SUPERTABLE:
				if (resolve) return getSupertable();
				return basicGetSupertable();
			case TablesPackage.TABLE__SUBTABLES:
				return getSubtables();
			case TablesPackage.TABLE__SCHEMA:
				return getSchema();
			case TablesPackage.TABLE__UDT:
				if (resolve) return getUdt();
				return basicGetUdt();
			case TablesPackage.TABLE__TRIGGERS:
				return getTriggers();
			case TablesPackage.TABLE__INDEX:
				return getIndex();
			case TablesPackage.TABLE__SELF_REF_COLUMN_GENERATION:
				return getSelfRefColumnGeneration();
			case TablesPackage.TABLE__INSERTABLE:
				return isInsertable() ? Boolean.TRUE : Boolean.FALSE;
			case TablesPackage.TABLE__UPDATABLE:
				return isUpdatable() ? Boolean.TRUE : Boolean.FALSE;
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case TablesPackage.TABLE__COLUMNS:
				getColumns().clear();
				getColumns().addAll((Collection<? extends Column>)newValue);
				return;
			case TablesPackage.TABLE__SUPERTABLE:
				setSupertable((Table)newValue);
				return;
			case TablesPackage.TABLE__SUBTABLES:
				getSubtables().clear();
				getSubtables().addAll((Collection<? extends Table>)newValue);
				return;
			case TablesPackage.TABLE__SCHEMA:
				setSchema((Schema)newValue);
				return;
			case TablesPackage.TABLE__UDT:
				setUdt((StructuredUserDefinedType)newValue);
				return;
			case TablesPackage.TABLE__TRIGGERS:
				getTriggers().clear();
				getTriggers().addAll((Collection<? extends Trigger>)newValue);
				return;
			case TablesPackage.TABLE__INDEX:
				getIndex().clear();
				getIndex().addAll((Collection<? extends Index>)newValue);
				return;
			case TablesPackage.TABLE__SELF_REF_COLUMN_GENERATION:
				setSelfRefColumnGeneration((ReferenceType)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case TablesPackage.TABLE__COLUMNS:
				getColumns().clear();
				return;
			case TablesPackage.TABLE__SUPERTABLE:
				setSupertable((Table)null);
				return;
			case TablesPackage.TABLE__SUBTABLES:
				getSubtables().clear();
				return;
			case TablesPackage.TABLE__SCHEMA:
				setSchema((Schema)null);
				return;
			case TablesPackage.TABLE__UDT:
				setUdt((StructuredUserDefinedType)null);
				return;
			case TablesPackage.TABLE__TRIGGERS:
				getTriggers().clear();
				return;
			case TablesPackage.TABLE__INDEX:
				getIndex().clear();
				return;
			case TablesPackage.TABLE__SELF_REF_COLUMN_GENERATION:
				setSelfRefColumnGeneration(SELF_REF_COLUMN_GENERATION_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case TablesPackage.TABLE__COLUMNS:
				return columns != null && !columns.isEmpty();
			case TablesPackage.TABLE__SUPERTABLE:
				return supertable != null;
			case TablesPackage.TABLE__SUBTABLES:
				return subtables != null && !subtables.isEmpty();
			case TablesPackage.TABLE__SCHEMA:
				return getSchema() != null;
			case TablesPackage.TABLE__UDT:
				return udt != null;
			case TablesPackage.TABLE__TRIGGERS:
				return triggers != null && !triggers.isEmpty();
			case TablesPackage.TABLE__INDEX:
				return index != null && !index.isEmpty();
			case TablesPackage.TABLE__SELF_REF_COLUMN_GENERATION:
				return selfRefColumnGeneration != SELF_REF_COLUMN_GENERATION_EDEFAULT;
			case TablesPackage.TABLE__INSERTABLE:
				return isInsertable() != INSERTABLE_EDEFAULT;
			case TablesPackage.TABLE__UPDATABLE:
				return isUpdatable() != UPDATABLE_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (selfRefColumnGeneration: ");
		result.append(selfRefColumnGeneration);
		result.append(')');
		return result.toString();
	}

} //TableImpl
